/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.7.3(14ab24ad53d8d969e86bae0096ecc3b954d0faa0)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
(function(){var e,t,n=["require","exports","vs/base/common/winjs.base","vs/base/common/errors","vs/editor/common/core/range","vs/base/common/platform","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/strings","vs/base/common/event","vs/base/common/cancellation","vs/base/common/uri","vs/base/common/map","vs/editor/common/core/position","vs/base/common/diff/diffChange","vs/base/common/diff/diff","vs/base/common/callbackList","vs/editor/common/model/mirrorModel2","vs/base/common/async","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/core/characterClassifier","vs/base/common/keyCodes","vs/base/common/filters","vs/editor/common/core/selection","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneBase","vs/base/common/worker/simpleWorker","vs/base/common/winjs.base.raw","vs/editor/common/services/editorSimpleWorker"],r=function(e){for(var t=[],r=0,i=e.length;r<i;r++)t[r]=n[e[r]];return t},i=this;!function(t){function n(){return!!("undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0)||"undefined"!=typeof process&&"win32"===process.platform}function r(){return U?T.performance.now():Date.now()}function o(){b="function"==typeof T.importScripts,C="undefined"!=typeof process&&"undefined"!=typeof process.versions&&"undefined"!=typeof process.versions.electron&&"renderer"===process.type,E="undefined"!=typeof process&&"undefined"!=typeof process.versions&&"undefined"!=typeof process.versions.electron&&"browser"===process.type,S="undefined"!=typeof module&&!!module.exports,P=new A(b?new w:S?new D:new N),M=new y(P),P.setModuleManager(M)}function s(){S||(T.console||(T.console={}),T.console.log||(T.console.log=function(){}),T.console.warn||(T.console.warn=T.console.log),T.console.error||(T.console.error=T.console.log))}function u(){b||S||(window.onload=function(){var e,t,n,r=document.getElementsByTagName("script");for(e=0,t=r.length;e<t&&!(n=r[e].getAttribute("data-main"));e++);n&&M.defineModule(c.generateAnonymousModule(),[n],null,null,null,new d(new h,""))})}function a(){if(o(),s(),u(),S){var t=T.require||require,n=function(e){M.getRecorder().record(m.NodeBeginNativeRequire,e);var n=t(e);return M.getRecorder().record(m.NodeEndNativeRequire,e),n};T.nodeRequire=n,x.nodeRequire=n}S&&!C?(module.exports=x,e=function(){k.apply(null,arguments)},require=x):("undefined"!=typeof T.require&&"function"!=typeof T.require&&x.config(T.require),C?e=function(){k.apply(null,arguments)}:T.define=e=k,T.require=x,T.require.__$__nodeRequire=n)}var l=n(),c=function(){function e(){}return e.fileUriToFilePath=function(e){if(e=decodeURI(e),l){if(/^file:\/\/\//.test(e))return e.substr(8);if(/^file:\/\//.test(e))return e.substr(5)}else if(/^file:\/\//.test(e))return e.substr(7);return e},e.startsWith=function(e,t){return e.length>=t.length&&e.substr(0,t.length)===t},e.endsWith=function(e,t){return e.length>=t.length&&e.substr(e.length-t.length)===t},e.containsQueryString=function(e){return/^[^\#]*\?/gi.test(e)},e.isAbsolutePath=function(t){return e.startsWith(t,"http://")||e.startsWith(t,"https://")||e.startsWith(t,"file://")||e.startsWith(t,"/")},e.forEachProperty=function(e,t){if(e){var n;for(n in e)e.hasOwnProperty(n)&&t(n,e[n])}},e.isEmpty=function(t){var n=!0;return e.forEachProperty(t,function(){n=!1}),n},e.isArray=function(e){return Array.isArray?Array.isArray(e):"[object Array]"===Object.prototype.toString.call(e)},e.recursiveClone=function(t){if(!t||"object"!=typeof t)return t;var n=e.isArray(t)?[]:{};return e.forEachProperty(t,function(t,r){r&&"object"==typeof r?n[t]=e.recursiveClone(r):n[t]=r}),n},e.generateAnonymousModule=function(){return"===anonymous"+e.NEXT_ANONYMOUS_ID++ +"==="},e.isAnonymousModule=function(e){return 0===e.indexOf("===anonymous")},e.NEXT_ANONYMOUS_ID=1,e}();t.Utilities=c;var f=function(){function e(){}return e.validateConfigurationOptions=function(e){function t(e){return"load"===e.errorCode?(console.error('Loading "'+e.moduleId+'" failed'),console.error("Detail: ",e.detail),e.detail&&e.detail.stack&&console.error(e.detail.stack),console.error("Here are the modules that depend on it:"),void console.error(e.neededBy)):"factory"===e.errorCode?(console.error('The factory method of "'+e.moduleId+'" has thrown an exception'),console.error(e.detail),void(e.detail&&e.detail.stack&&console.error(e.detail.stack))):void 0}return e=e||{},"string"!=typeof e.baseUrl&&(e.baseUrl=""),"boolean"!=typeof e.isBuild&&(e.isBuild=!1),"object"!=typeof e.paths&&(e.paths={}),"object"!=typeof e.bundles&&(e.bundles=[]),"object"!=typeof e.shim&&(e.shim={}),"object"!=typeof e.config&&(e.config={}),"undefined"==typeof e.catchError&&(e.catchError=b),"string"!=typeof e.urlArgs&&(e.urlArgs=""),"function"!=typeof e.onError&&(e.onError=t),"object"==typeof e.ignoreDuplicateModules&&c.isArray(e.ignoreDuplicateModules)||(e.ignoreDuplicateModules=[]),e.baseUrl.length>0&&(c.endsWith(e.baseUrl,"/")||(e.baseUrl+="/")),Array.isArray(e.nodeModules)||(e.nodeModules=[]),e},e.mergeConfigurationOptions=function(t,n){void 0===t&&(t=null),void 0===n&&(n=null);var r=c.recursiveClone(n||{});return c.forEachProperty(t,function(e,t){"bundles"===e&&"undefined"!=typeof r.bundles?c.isArray(t)?r.bundles=r.bundles.concat(t):c.forEachProperty(t,function(e,t){var n={location:e,modules:t};r.bundles.push(n)}):"ignoreDuplicateModules"===e&&"undefined"!=typeof r.ignoreDuplicateModules?r.ignoreDuplicateModules=r.ignoreDuplicateModules.concat(t):"paths"===e&&"undefined"!=typeof r.paths?c.forEachProperty(t,function(e,t){return r.paths[e]=t}):"shim"===e&&"undefined"!=typeof r.shim?c.forEachProperty(t,function(e,t){return r.shim[e]=t}):"config"===e&&"undefined"!=typeof r.config?c.forEachProperty(t,function(e,t){return r.config[e]=t}):r[e]=c.recursiveClone(t)}),e.validateConfigurationOptions(r)},e}();t.ConfigurationOptionsUtil=f;var h=function(){function e(e){if(this.options=f.mergeConfigurationOptions(e),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this._createShimModules(),this._createOverwriteModuleIdToPath(),""===this.options.baseUrl){if(S&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename){var t=this.options.nodeRequire.main.filename,n=Math.max(t.lastIndexOf("/"),t.lastIndexOf("\\"));this.options.baseUrl=t.substring(0,n+1)}if(S&&this.options.nodeMain){var t=this.options.nodeMain,n=Math.max(t.lastIndexOf("/"),t.lastIndexOf("\\"));this.options.baseUrl=t.substring(0,n+1)}}}return e.prototype._createOverwriteModuleIdToPath=function(){this.overwriteModuleIdToPath={};for(var e=0;e<this.options.bundles.length;e++){var t=this.options.bundles[e],n=t.location;if(t.modules)for(var r=0;r<t.modules.length;r++)this.overwriteModuleIdToPath[t.modules[r]]=n}},e.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var e=0;e<this.options.ignoreDuplicateModules.length;e++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[e]]=!0},e.prototype._createSortedPathsRules=function(){var e=this;this.sortedPathsRules=[],c.forEachProperty(this.options.paths,function(t,n){c.isArray(n)?e.sortedPathsRules.push({from:t,to:n}):e.sortedPathsRules.push({from:t,to:[n]})}),this.sortedPathsRules.sort(function(e,t){return t.from.length-e.from.length})},e.prototype._ensureShimModule1=function(e,t){for(var n=0;n<t.length;n++){var r=t[n];this.shimModules.hasOwnProperty(r)||this._ensureShimModule1(r,[])}this.shimModules[e]={stack:null,dependencies:t,callback:null},this.options.isBuild&&(this.shimModulesStr[e]="null")},e.prototype._ensureShimModule2=function(e,t){this.shimModules[e]={stack:null,dependencies:t.deps||[],callback:function(){for(var e=[],n=0;n<arguments.length;n++)e[n-0]=arguments[n];if("function"==typeof t.init){var r=t.init.apply(T,e);if("undefined"!=typeof r)return r}if("function"==typeof t.exports)return t.exports.apply(T,e);if("string"==typeof t.exports){for(var i=t.exports.split("."),o=T,s=0;s<i.length;s++)o&&(o=o[i[s]]);return o}return t.exports||{}}},this.options.isBuild&&("function"==typeof t.init?this.shimModulesStr[e]=t.init.toString():"function"==typeof t.exports?this.shimModulesStr[e]=t.exports.toString():"string"==typeof t.exports?this.shimModulesStr[e]="function() { return this."+t.exports+"; }":this.shimModulesStr[e]=JSON.stringify(t.exports))},e.prototype._createShimModules=function(){var e=this;this.shimModules={},this.shimModulesStr={},c.forEachProperty(this.options.shim,function(t,n){if(n)return c.isArray(n)?void e._ensureShimModule1(t,n):void e._ensureShimModule2(t,n)})},e.prototype.cloneAndMerge=function(t){return new e(f.mergeConfigurationOptions(t,this.options))},e.prototype.getOptionsLiteral=function(){return this.options},e.prototype._applyPaths=function(e){for(var t,n=0,r=this.sortedPathsRules.length;n<r;n++)if(t=this.sortedPathsRules[n],c.startsWith(e,t.from)){for(var i=[],o=0,s=t.to.length;o<s;o++)i.push(t.to[o]+e.substr(t.from.length));return i}return[e]},e.prototype._addUrlArgsToUrl=function(e){return c.containsQueryString(e)?e+"&"+this.options.urlArgs:e+"?"+this.options.urlArgs},e.prototype._addUrlArgsIfNecessaryToUrl=function(e){return this.options.urlArgs?this._addUrlArgsToUrl(e):e},e.prototype._addUrlArgsIfNecessaryToUrls=function(e){if(this.options.urlArgs)for(var t=0,n=e.length;t<n;t++)e[t]=this._addUrlArgsToUrl(e[t]);return e},e.prototype.moduleIdToPaths=function(e){if(this.isBuild()&&this.options.nodeModules.indexOf(e)>=0)return["empty:"];var t=e;this.overwriteModuleIdToPath.hasOwnProperty(t)&&(t=this.overwriteModuleIdToPath[t]);var n;if(c.endsWith(t,".js")||c.isAbsolutePath(t))c.endsWith(t,".js")||c.containsQueryString(t)||(t+=".js"),n=[t];else{n=this._applyPaths(t);for(var r=0,i=n.length;r<i;r++)this.isBuild()&&"empty:"===n[r]||(c.isAbsolutePath(n[r])||(n[r]=this.options.baseUrl+n[r]),c.endsWith(n[r],".js")||c.containsQueryString(n[r])||(n[r]=n[r]+".js"))}return this._addUrlArgsIfNecessaryToUrls(n)},e.prototype.requireToUrl=function(e){var t=e;return c.isAbsolutePath(t)||(t=this._applyPaths(t)[0],c.isAbsolutePath(t)||(t=this.options.baseUrl+t)),this._addUrlArgsIfNecessaryToUrl(t)},e.prototype.isShimmed=function(e){return this.shimModules.hasOwnProperty(e)},e.prototype.isBuild=function(){return this.options.isBuild},e.prototype.getShimmedModuleDefine=function(e){return this.shimModules[e]},e.prototype.getShimmedModulesStr=function(e){return this.shimModulesStr[e]},e.prototype.isDuplicateMessageIgnoredFor=function(e){return this.ignoreDuplicateModulesMap.hasOwnProperty(e)},e.prototype.getConfigForModule=function(e){if(this.options.config)return this.options.config[e]},e.prototype.shouldCatchError=function(){return this.options.catchError},e.prototype.shouldRecordStats=function(){return this.options.recordStats},e.prototype.onError=function(e){this.options.onError(e)},e}();t.Configuration=h;var d=function(){function e(e,t){this._config=e;var n=t.lastIndexOf("/");n!==-1?this.fromModulePath=t.substr(0,n+1):this.fromModulePath=""}return e.prototype.isBuild=function(){return this._config.isBuild()},e._normalizeModuleId=function(e){var t,n=e;for(t=/\/\.\//;t.test(n);)n=n.replace(t,"/");for(n=n.replace(/^\.\//g,""),t=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;t.test(n);)n=n.replace(t,"/");return n=n.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,"")},e.prototype.resolveModule=function(t){var n=t;return c.isAbsolutePath(n)||(c.startsWith(n,"./")||c.startsWith(n,"../"))&&(n=e._normalizeModuleId(this.fromModulePath+n)),n},e.prototype.moduleIdToPaths=function(e){var t=this._config.moduleIdToPaths(e);return S&&e.indexOf("/")===-1&&t.push("node|"+this.fromModulePath+"|"+e),t},e.prototype.requireToUrl=function(e){return this._config.requireToUrl(e)},e.prototype.shouldCatchError=function(){return this._config.shouldCatchError()},e.prototype.onError=function(e){this._config.onError(e)},e}();t.ModuleIdResolver=d;var p=function(){function e(e,t,n,r,i,o,s,u){void 0===u&&(u=null),this._id=e,this._dependencies=t,this._dependenciesValues=[],this._callback=n,this._errorback=r,this._recorder=i,this._moduleIdResolver=o,this._exports={},this._exportsPassedIn=!1,this._config=s,this._defineCallStack=u,this._digestDependencies(),0===this._unresolvedDependenciesCount&&this._complete()}return e.prototype._digestDependencies=function(){var e=this;this._unresolvedDependenciesCount=this._dependencies.length,this._normalizedDependencies=[],this._managerDependencies=[],this._managerDependenciesMap={};var t,n,r;for(t=0,n=this._dependencies.length;t<n;t++)if(r=this._dependencies[t])if("exports"===r)this._exportsPassedIn=!0,this._normalizedDependencies[t]=r,this._dependenciesValues[t]=this._exports,this._unresolvedDependenciesCount--;else if("module"===r)this._normalizedDependencies[t]=r,this._dependenciesValues[t]={id:this._id,config:function(){return e._config}},this._unresolvedDependenciesCount--;else if("require"===r)this._normalizedDependencies[t]=r,this.addManagerDependency(r,t);else{var i=r.indexOf("!");if(i>=0){var o=r.substring(0,i),s=r.substring(i+1,r.length);r=this._moduleIdResolver.resolveModule(o)+"!"+s}else r=this._moduleIdResolver.resolveModule(r);this._normalizedDependencies[t]=r,this.addManagerDependency(r,t)}else console.warn("Please check module "+this._id+", the dependency list looks broken"),this._normalizedDependencies[t]=r,this._dependenciesValues[t]=null,this._unresolvedDependenciesCount--},e.prototype.addManagerDependency=function(e,t){if(this._managerDependenciesMap.hasOwnProperty(e))throw new Error("Module "+this._id+" contains multiple times a dependency to "+e);this._managerDependencies.push(e),this._managerDependenciesMap[e]=t},e.prototype.renameDependency=function(e,t){if(!this._managerDependenciesMap.hasOwnProperty(e))throw new Error("Loader: Cannot rename an unknown dependency!");var n=this._managerDependenciesMap[e];delete this._managerDependenciesMap[e],this._managerDependenciesMap[t]=n,this._normalizedDependencies[n]=t},e.prototype.getId=function(){return this._id},e.prototype.getModuleIdResolver=function(){return this._moduleIdResolver},e.prototype.isExportsPassedIn=function(){return this._exportsPassedIn},e.prototype.getExports=function(){return this._exports},e.prototype.getDependencies=function(){return this._managerDependencies},e.prototype.getNormalizedDependencies=function(){return this._normalizedDependencies},e.prototype.getDefineCallStack=function(){return this._defineCallStack},e.prototype._invokeFactory=function(){if(this._moduleIdResolver.isBuild()&&!c.isAnonymousModule(this._id))return{returnedValue:null,producedError:null};var e=null,t=null;if(this._moduleIdResolver.shouldCatchError())try{t=this._callback.apply(T,this._dependenciesValues)}catch(t){e=t}finally{}else t=this._callback.apply(T,this._dependenciesValues);return{returnedValue:t,producedError:e}},e.prototype._complete=function(){var e=null;if(this._callback)if("function"==typeof this._callback){this._recorder.record(m.BeginInvokeFactory,this._id);var t=this._invokeFactory();e=t.producedError,this._recorder.record(m.EndInvokeFactory,this._id),e||"undefined"==typeof t.returnedValue||this._exportsPassedIn&&!c.isEmpty(this._exports)||(this._exports=t.returnedValue)}else this._exports=this._callback;e&&this.getModuleIdResolver().onError({errorCode:"factory",moduleId:this._id,detail:e})},e.prototype.cleanUp=function(){this._moduleIdResolver&&!this._moduleIdResolver.isBuild()&&(this._normalizedDependencies=null,this._moduleIdResolver=null),this._dependencies=null,this._dependenciesValues=null,this._callback=null,this._managerDependencies=null,this._managerDependenciesMap=null},e.prototype.onDependencyError=function(e){return!!this._errorback&&(this._errorback(e),!0)},e.prototype.resolveDependency=function(e,t){if(!this._managerDependenciesMap.hasOwnProperty(e))throw new Error("Cannot resolve a dependency I do not have!");this._dependenciesValues[this._managerDependenciesMap[e]]=t,delete this._managerDependenciesMap[e],this._unresolvedDependenciesCount--,0===this._unresolvedDependenciesCount&&this._complete()},e.prototype.isComplete=function(){return 0===this._unresolvedDependenciesCount},e}();t.Module=p,function(e){e[e.LoaderAvailable=1]="LoaderAvailable",e[e.BeginLoadingScript=10]="BeginLoadingScript",e[e.EndLoadingScriptOK=11]="EndLoadingScriptOK",e[e.EndLoadingScriptError=12]="EndLoadingScriptError",e[e.BeginInvokeFactory=21]="BeginInvokeFactory",e[e.EndInvokeFactory=22]="EndInvokeFactory",e[e.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",e[e.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",e[e.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",e[e.NodeEndNativeRequire=34]="NodeEndNativeRequire"}(t.LoaderEventType||(t.LoaderEventType={}));var m=t.LoaderEventType,_=function(){function e(e,t,n){this.type=e,this.detail=t,this.timestamp=n}return e}();t.LoaderEvent=_;var g=function(){function e(e){this._events=[new _(m.LoaderAvailable,"",e)]}return e.prototype.record=function(e,t){this._events.push(new _(e,t,r()))},e.prototype.getEvents=function(){return this._events},e}();t.LoaderEventRecorder=g;var v=function(){function e(){}return e.prototype.record=function(e,t){},e.prototype.getEvents=function(){return[]},e.INSTANCE=new e,e}();t.NullLoaderEventRecorder=v;var y=function(){function e(e){this._recorder=null,this._config=new h,this._scriptLoader=e,this._modules={},this._knownModules={},this._inverseDependencies={},this._dependencies={},this._inversePluginDependencies={},this._queuedDefineCalls=[],this._loadingScriptsCount=0,this._resolvedScriptPaths={},this._checksums={}}return e._findRelevantLocationInStack=function(e,t){for(var n=function(e){return e.replace(/\\/g,"/")},r=n(e),i=t.split(/\n/),o=0;o<i.length;o++){var s=i[o].match(/(.*):(\d+):(\d+)\)?$/);if(s){var u=s[1],a=s[2],l=s[3],c=Math.max(u.lastIndexOf(" ")+1,u.lastIndexOf("(")+1);if(u=u.substr(c),u=n(u),u===r){var f={line:parseInt(a,10),col:parseInt(l,10)};return 1===f.line&&(f.col-="(function (require, define, __filename, __dirname) { ".length),f}}}throw new Error("Could not correlate define call site for needle "+e)},e.prototype.getBuildInfo=function(){var t=this;return this._config.isBuild()?Object.keys(this._modules).map(function(n){var r=t._modules[n],i=t._resolvedScriptPaths[n]||null,o=r.getDefineCallStack();return{id:n,path:i,defineLocation:i&&o?e._findRelevantLocationInStack(i,o):null,dependencies:r.getNormalizedDependencies(),shim:t._config.isShimmed(n)?t._config.getShimmedModulesStr(n):null,exports:r.getExports()}}):null},e.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new g(L):this._recorder=v.INSTANCE),this._recorder},e.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},e.prototype.recordChecksum=function(e,t){this._checksums[e]=t},e.prototype.getChecksums=function(){return this._checksums},e.prototype.enqueueDefineModule=function(e,t,n){0===this._loadingScriptsCount?this.defineModule(e,t,n,null,null):this._queuedDefineCalls.push({id:e,stack:null,dependencies:t,callback:n})},e.prototype.enqueueDefineAnonymousModule=function(e,t){var n=null;this._config.isBuild()&&(n=new Error("StackLocation").stack),this._queuedDefineCalls.push({id:null,stack:n,dependencies:e,callback:t})},e.prototype.defineModule=function(e,t,n,r,i,o){if(void 0===o&&(o=new d(this._config,e)),this._modules.hasOwnProperty(e))return void(this._config.isDuplicateMessageIgnoredFor(e)||console.warn("Duplicate definition of module '"+e+"'"));var s=this._config.getConfigForModule(e),u=new p(e,t,n,r,this.getRecorder(),o,s,i);this._modules[e]=u,this._resolve(u)},e.prototype._relativeRequire=function(e,t,n,r){return"string"==typeof t?this.synchronousRequire(t,e):void this.defineModule(c.generateAnonymousModule(),t,n,r,null,e)},e.prototype.synchronousRequire=function(e,t){void 0===t&&(t=new d(this._config,e));var n=t.resolveModule(e),r=n.indexOf("!");if(r>=0){var i=n.substring(0,r),o=n.substring(r+1,n.length),s={};this._modules.hasOwnProperty(i)&&(s=this._modules[i]);var u=function(e){return t.resolveModule(e)};o="function"==typeof s.normalize?s.normalize(o,u):u(o),n=i+"!"+o}if(!this._modules.hasOwnProperty(n))throw new Error("Check dependency list! Synchronous require cannot resolve module '"+n+"'. This is the first mention of this module!");var a=this._modules[n];if(!a.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+n+"'. This module has not been resolved completely yet.");return a.getExports()},e.prototype.configure=function(e,t){var n=this._config.shouldRecordStats();t?this._config=new h(e):this._config=this._config.cloneAndMerge(e),this._config.shouldRecordStats()&&!n&&(this._recorder=null)},e.prototype.getConfigurationOptions=function(){return this._config.getOptionsLiteral()},e.prototype._onLoad=function(e){var t;if(this._loadingScriptsCount--,this._config.isShimmed(e))t=this._config.getShimmedModuleDefine(e),this.defineModule(e,t.dependencies,t.callback,null,t.stack);else if(0===this._queuedDefineCalls.length)this._loadingScriptsCount++,this._onLoadError(e,new Error("No define call received from module "+e+"."));else for(;this._queuedDefineCalls.length>0;){if(t=this._queuedDefineCalls.shift(),t.id===e||null===t.id){t.id=e,this.defineModule(t.id,t.dependencies,t.callback,null,t.stack);break}this.defineModule(t.id,t.dependencies,t.callback,null,t.stack)}if(0===this._loadingScriptsCount)for(;this._queuedDefineCalls.length>0;)t=this._queuedDefineCalls.shift(),null===t.id?(console.warn("Found an unmatched anonymous define call in the define queue. Ignoring it!"),console.warn(t.callback)):this.defineModule(t.id,t.dependencies,t.callback,null,t.stack)},e.prototype._onLoadError=function(e,t){this._loadingScriptsCount--;var n,r={errorCode:"load",moduleId:e,neededBy:this._inverseDependencies[e]?this._inverseDependencies[e].slice(0):[],detail:t},i={},o=!1,s=[];for(s.push(e),i[e]=!0;s.length>0;)if(n=s.shift(),this._modules[n]&&(o=this._modules[n].onDependencyError(r)||o),this._inverseDependencies[n])for(var u=0,a=this._inverseDependencies[n].length;u<a;u++)i.hasOwnProperty(this._inverseDependencies[n][u])||(s.push(this._inverseDependencies[n][u]),i[this._inverseDependencies[n][u]]=!0);o||this._config.onError(r)},e.prototype._onModuleComplete=function(e,t){var n,r,i,o;if(delete this._dependencies[e],this._inverseDependencies.hasOwnProperty(e)){var s=this._inverseDependencies[e];for(delete this._inverseDependencies[e],n=0,r=s.length;n<r;n++)i=s[n],o=this._modules[i],o.resolveDependency(e,t),o.isComplete()&&this._onModuleComplete(i,o.getExports())}if(this._inversePluginDependencies.hasOwnProperty(e)){var u=this._inversePluginDependencies[e];for(delete this._inversePluginDependencies[e],n=0,r=u.length;n<r;n++){var a=u[n].moduleId,l=this._modules[a];this._resolvePluginDependencySync(a,u[n].dependencyId,t),l.isComplete()&&this._onModuleComplete(a,l.getExports())}}c.isAnonymousModule(e)?(delete this._modules[e],delete this._dependencies[e]):this._modules[e].cleanUp()},e.prototype._hasDependencyPath=function(e,t){var n,r,i,o,s,u={},a=[];for(a.push(e),u[e]=!0;a.length>0;)if(i=a.shift(),this._dependencies.hasOwnProperty(i))for(o=this._dependencies[i],n=0,r=o.length;n<r;n++){if(s=o[n],s===t)return!0;u.hasOwnProperty(s)||(u[s]=!0,a.push(s))}return!1},e.prototype._findCyclePath=function(e,t,n){if(e===t||50===n)return[e];if(!this._dependencies.hasOwnProperty(e))return null;for(var r,i=this._dependencies[e],o=0,s=i.length;o<s;o++)if(r=this._findCyclePath(i[o],t,n+1),null!==r)return r.push(e),r;return null},e.prototype._createRequire=function(e){var t=this,n=function(n,r,i){return t._relativeRequire(e,n,r,i)};return n.toUrl=function(t){return e.requireToUrl(e.resolveModule(t))},n.getStats=function(){return t.getLoaderEvents()},n.getChecksums=function(){return t.getChecksums()},n.__$__nodeRequire=T.nodeRequire,n},e.prototype._resolvePluginDependencySync=function(e,t,n){var r=this,i=this._modules[e],o=i.getModuleIdResolver(),s=t.indexOf("!"),u=t.substring(0,s),a=t.substring(s+1,t.length),l=function(e){return o.resolveModule(e)};if(a="function"==typeof n.normalize?n.normalize(a,l):l(a),n.dynamic){var c=function(n){i.resolveDependency(t,n),i.isComplete()&&r._onModuleComplete(e,i.getExports())};c.error=function(n){r._config.onError({errorCode:"load",moduleId:t,neededBy:[e],detail:n})},n.load(a,this._createRequire(o),c,this._config.getOptionsLiteral())}else{var f=t;t=u+"!"+a,i.renameDependency(f,t),this._resolveDependency(e,t,function(e){var i=function(e){r.defineModule(t,[],e,null,null)};i.error=function(e){r._config.onError({errorCode:"load",moduleId:t,neededBy:r._inverseDependencies[t]?r._inverseDependencies[t].slice(0):[],detail:e})},n.load(a,r._createRequire(o),i,r._config.getOptionsLiteral())})}},e.prototype._resolvePluginDependencyAsync=function(e,t){var n=this._modules[e],r=t.indexOf("!"),i=t.substring(0,r);this._inversePluginDependencies[i]=this._inversePluginDependencies[i]||[],this._inversePluginDependencies[i].push({moduleId:e,dependencyId:t}),this._modules.hasOwnProperty(i)||this._knownModules.hasOwnProperty(i)||(this._knownModules[i]=!0,this._loadModule(n.getModuleIdResolver(),i))},e.prototype._resolvePluginDependency=function(e,t){var n=t.indexOf("!"),r=t.substring(0,n);this._modules.hasOwnProperty(r)&&this._modules[r].isComplete()?this._resolvePluginDependencySync(e,t,this._modules[r].getExports()):this._resolvePluginDependencyAsync(e,t)},e.prototype._resolveShimmedDependency=function(e,t,n){var r=this._config.getShimmedModuleDefine(t);r.dependencies.length>0?this.defineModule(c.generateAnonymousModule(),r.dependencies,function(){return n(t)},null,null,new d(this._config,t)):n(t)},e.prototype._resolveDependency=function(e,t,n){var r=this._modules[e];if(this._modules.hasOwnProperty(t)&&this._modules[t].isComplete())r.resolveDependency(t,this._modules[t].getExports());else if(this._dependencies[e].push(t),this._hasDependencyPath(t,e)){console.warn("There is a dependency cycle between '"+t+"' and '"+e+"'. The cyclic path follows:");var i=this._findCyclePath(t,e,0);i.reverse(),i.push(t),console.warn(i.join(" => \n"));var o,s=this._modules.hasOwnProperty(t)?this._modules[t]:null;s&&s.isExportsPassedIn()&&(o=s.getExports()),r.resolveDependency(t,o)}else this._inverseDependencies[t]=this._inverseDependencies[t]||[],this._inverseDependencies[t].push(e),this._modules.hasOwnProperty(t)||this._knownModules.hasOwnProperty(t)||(this._knownModules[t]=!0,this._config.isShimmed(t)?this._resolveShimmedDependency(e,t,n):n(t))},e.prototype._loadModule=function(e,t){var n=this;this._loadingScriptsCount++;var r=e.moduleIdToPaths(t),i=-1,o=function(e){if(i++,i>=r.length)n._onLoadError(t,e);else{var s=r[i],u=n.getRecorder();if(n._config.isBuild()&&"empty:"===s)return n._resolvedScriptPaths[t]=s,n.enqueueDefineModule(t,[],null),void n._onLoad(t);u.record(m.BeginLoadingScript,s),n._scriptLoader.load(s,function(){n._config.isBuild()&&(n._resolvedScriptPaths[t]=s),u.record(m.EndLoadingScriptOK,s),n._onLoad(t)},function(e){u.record(m.EndLoadingScriptError,s),o(e)},u)}};o(null)},e.prototype._resolve=function(e){var t,n,r,i,o,s,u=this;r=e.getId(),i=e.getDependencies(),s=e.getModuleIdResolver(),this._dependencies[r]=[];var a=function(e){return u._loadModule(s,e)};for(t=0,n=i.length;t<n;t++)o=i[t],"require"!==o?o.indexOf("!")>=0?this._resolvePluginDependency(r,o):this._resolveDependency(r,o,a):e.resolveDependency(o,this._createRequire(s));e.isComplete()&&this._onModuleComplete(r,e.getExports())},e}();t.ModuleManager=y;var b,C,E,S,P,M,L,A=function(){function e(e){this.actualScriptLoader=e,this.callbackMap={}}return e.prototype.setModuleManager=function(e){this.actualScriptLoader.setModuleManager(e)},e.prototype.load=function(e,t,n,r){var i=this,o={callback:t,errorback:n};return this.callbackMap.hasOwnProperty(e)?void this.callbackMap[e].push(o):(this.callbackMap[e]=[o],void this.actualScriptLoader.load(e,function(){return i.triggerCallback(e)},function(t){return i.triggerErrorback(e,t)},r))},e.prototype.triggerCallback=function(e){var t=this.callbackMap[e];delete this.callbackMap[e];for(var n=0;n<t.length;n++)t[n].callback()},e.prototype.triggerErrorback=function(e,t){var n=this.callbackMap[e];delete this.callbackMap[e];for(var r=0;r<n.length;r++)n[r].errorback(t)},e}(),N=function(){function e(){}return e.prototype.attachListenersV1=function(e,t,n){var r=function(){e.detachEvent("onreadystatechange",i),e.addEventListener&&e.removeEventListener("error",o)},i=function(n){"loaded"!==e.readyState&&"complete"!==e.readyState||(r(),t())},o=function(e){r(),n(e)};e.attachEvent("onreadystatechange",i),e.addEventListener&&e.addEventListener("error",o)},e.prototype.attachListenersV2=function(e,t,n){var r=function(){e.removeEventListener("load",i),e.removeEventListener("error",o)},i=function(e){r(),t()},o=function(e){r(),n(e)};e.addEventListener("load",i),e.addEventListener("error",o)},e.prototype.setModuleManager=function(e){},e.prototype.load=function(e,t,n){var r=document.createElement("script");r.setAttribute("async","async"),r.setAttribute("type","text/javascript"),T.attachEvent?this.attachListenersV1(r,t,n):this.attachListenersV2(r,t,n),r.setAttribute("src",e),document.getElementsByTagName("head")[0].appendChild(r)},e}(),w=function(){function e(){this.loadCalls=[],this.loadTimeout=-1}return e.prototype.setModuleManager=function(e){},e.prototype.load=function(e,t,n){var r=this;this.loadCalls.push({scriptSrc:e,callback:t,errorback:n}),navigator.userAgent.indexOf("Firefox")>=0?this._load():this.loadTimeout===-1&&(this.loadTimeout=setTimeout(function(){r.loadTimeout=-1,r._load()},0))},e.prototype._load=function(){var e=this.loadCalls;this.loadCalls=[];var t,n=e.length,r=[];for(t=0;t<n;t++)r.push(e[t].scriptSrc);var i=!1;try{importScripts.apply(null,r)}catch(r){for(i=!0,t=0;t<n;t++)e[t].errorback(r)}if(!i)for(t=0;t<n;t++)e[t].callback()},e}(),D=function(){function e(){this._initialized=!1}return e.prototype.setModuleManager=function(e){this._moduleManager=e},e.prototype._init=function(e){this._initialized||(this._initialized=!0,this._fs=e("fs"),this._vm=e("vm"),this._path=e("path"),this._crypto=e("crypto"))},e.prototype.load=function(t,n,r,i){var o=this,s=this._moduleManager.getConfigurationOptions(),u=s.checksum||!1,a=s.nodeRequire||T.nodeRequire,l=s.nodeInstrumenter||function(e){return e};if(this._init(a),/^node\|/.test(t)){var f=t.split("|"),h=null;try{i.record(m.NodeBeginNativeRequire,f[2]),h=a(f[2])}catch(e){return i.record(m.NodeEndNativeRequire,f[2]),void r(e)}i.record(m.NodeEndNativeRequire,f[2]),this._moduleManager.enqueueDefineAnonymousModule([],function(){return h}),n()}else t=c.fileUriToFilePath(t),this._fs.readFile(t,{encoding:"utf8"},function(s,a){if(s)return void r(s);if(u){var c=o._crypto.createHash("md5").update(a,"utf8").digest("base64").replace(/=+$/,"");o._moduleManager.recordChecksum(t,c)}i.record(m.NodeBeginEvaluatingScript,t);var f=o._path.normalize(t);if(C){var h=f.match(/^([a-z])\:(.*)/i);h&&(f=h[1].toUpperCase()+":"+h[2]),f="file:///"+f.replace(/\\/g,"/")}var d,p="(function (require, define, __filename, __dirname) { ",_="\n});";d=a.charCodeAt(0)===e._BOM?p+a.substring(1)+_:p+a+_,d=l(d,f);var g;g=/^v0\.12/.test(process.version)?o._vm.runInThisContext(d,{filename:f}):o._vm.runInThisContext(d,f),g.call(T,x,k,f,o._path.dirname(t)),i.record(m.NodeEndEvaluatingScript,t),n()})},e._BOM=65279,e}(),k=function(){function e(e,t,n){"string"!=typeof e&&(n=t,t=e,e=null),"object"==typeof t&&c.isArray(t)||(n=t,t=null),t||(t=["require","exports","module"]),e?M.enqueueDefineModule(e,t,n):M.enqueueDefineAnonymousModule(t,n)}return e.amd={jQuery:!0},e}(),x=function(){function e(){if(1===arguments.length){if(arguments[0]instanceof Object&&!c.isArray(arguments[0]))return void e.config(arguments[0]);if("string"==typeof arguments[0])return M.synchronousRequire(arguments[0]);
}if((2===arguments.length||3===arguments.length)&&c.isArray(arguments[0]))return void M.defineModule(c.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);throw new Error("Unrecognized require call")}return e.config=function(e,t){void 0===t&&(t=!1),M.configure(e,t)},e.getConfig=function(){return M.getConfigurationOptions()},e.reset=function(){M=new y(P),P.setModuleManager(M)},e.getBuildInfo=function(){return M.getBuildInfo()},e.getStats=function(){return M.getLoaderEvents()},e.getChecksums=function(){return M.getChecksums()},e}(),T=i,U=T.performance&&"function"==typeof T.performance.now;"function"==typeof T.define&&T.define.amd||(a(),L=r())}(t||(t={})),e(n[14],r([0,1]),function(e,t){"use strict";t.DifferenceType={Add:0,Remove:1,Change:2};var n=function(){function e(e,t,n,r){this.originalStart=e,this.originalLength=t,this.modifiedStart=n,this.modifiedLength=r}return e.prototype.getChangeType=function(){return 0===this.originalLength?t.DifferenceType.Add:0===this.modifiedLength?t.DifferenceType.Remove:t.DifferenceType.Change},e.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},e.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},e}();t.DiffChange=n}),e(n[15],r([0,1,14]),function(e,t,n){"use strict";function r(e){return{getLength:function(){return e.length},getElementHash:function(t){return e[t]}}}function i(e,t){return new c(r(e),r(t)).ComputeDiff()}t.stringDiff=i;var o=function(){function e(){}return e.Assert=function(e,t){if(!e)throw new Error(t)},e}();t.Debug=o;var s=function(){function e(){}return e.Copy=function(e,t,n,r,i){for(var o=0;o<i;o++)n[r+o]=e[t+o]},e}();t.MyArray=s;var u=1447,a=function(){function e(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return e.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new n.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},e.prototype.AddOriginalElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_originalCount++},e.prototype.AddModifiedElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_modifiedCount++},e.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},e.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},e}(),l=Object.prototype.hasOwnProperty,c=function(){function e(e,t,n){void 0===n&&(n=null),this.OriginalSequence=e,this.ModifiedSequence=t,this.ContinueProcessingPredicate=n,this.m_originalIds=[],this.m_modifiedIds=[],this.m_forwardHistory=[],this.m_reverseHistory=[],this.ComputeUniqueIdentifiers()}return e.prototype.ComputeUniqueIdentifiers=function(){var e=this.OriginalSequence.getLength(),t=this.ModifiedSequence.getLength();this.m_originalIds=new Array(e),this.m_modifiedIds=new Array(t);var n,r={},i=1;for(n=0;n<e;n++){var o=this.OriginalSequence.getElementHash(n);l.call(r,o)?this.m_originalIds[n]=r[o]:(this.m_originalIds[n]=i++,r[o]=this.m_originalIds[n])}for(n=0;n<t;n++){var s=this.ModifiedSequence.getElementHash(n);l.call(r,s)?this.m_modifiedIds[n]=r[s]:(this.m_modifiedIds[n]=i++,r[s]=this.m_modifiedIds[n])}},e.prototype.ElementsAreEqual=function(e,t){return this.m_originalIds[e]===this.m_modifiedIds[t]},e.prototype.ComputeDiff=function(){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1)},e.prototype._ComputeDiff=function(e,t,n,r){var i=[!1];return this.ComputeDiffRecursive(e,t,n,r,i)},e.prototype.ComputeDiffRecursive=function(e,t,r,i,s){for(s[0]=!1;e<=t&&r<=i&&this.ElementsAreEqual(e,r);)e++,r++;for(;t>=e&&i>=r&&this.ElementsAreEqual(t,i);)t--,i--;if(e>t||r>i){var u=void 0;return r<=i?(o.Assert(e===t+1,"originalStart should only be one more than originalEnd"),u=[new n.DiffChange(e,0,r,i-r+1)]):e<=t?(o.Assert(r===i+1,"modifiedStart should only be one more than modifiedEnd"),u=[new n.DiffChange(e,t-e+1,r,0)]):(o.Assert(e===t+1,"originalStart should only be one more than originalEnd"),o.Assert(r===i+1,"modifiedStart should only be one more than modifiedEnd"),u=[]),u}var a=[0],l=[0],c=this.ComputeRecursionPoint(e,t,r,i,a,l,s),f=a[0],h=l[0];if(null!==c)return c;if(!s[0]){var d=this.ComputeDiffRecursive(e,f,r,h,s),p=[];return p=s[0]?[new n.DiffChange(f+1,t-(f+1)+1,h+1,i-(h+1)+1)]:this.ComputeDiffRecursive(f+1,t,h+1,i,s),this.ConcatenateChanges(d,p)}return[new n.DiffChange(e,t-e+1,r,i-r+1)]},e.prototype.WALKTRACE=function(e,t,r,i,o,s,u,l,c,f,h,d,p,m,_,g,v,y){var b,C=null,E=null,S=new a,P=t,M=r,L=p[0]-g[0]-i,A=Number.MIN_VALUE,N=this.m_forwardHistory.length-1;do b=L+e,b===P||b<M&&c[b-1]<c[b+1]?(h=c[b+1],m=h-L-i,h<A&&S.MarkNextChange(),A=h,S.AddModifiedElement(h+1,m),L=b+1-e):(h=c[b-1]+1,m=h-L-i,h<A&&S.MarkNextChange(),A=h-1,S.AddOriginalElement(h,m+1),L=b-1-e),N>=0&&(c=this.m_forwardHistory[N],e=c[0],P=1,M=c.length-1);while(--N>=-1);if(C=S.getReverseChanges(),y[0]){var w=p[0]+1,D=g[0]+1;if(null!==C&&C.length>0){var k=C[C.length-1];w=Math.max(w,k.getOriginalEnd()),D=Math.max(D,k.getModifiedEnd())}E=[new n.DiffChange(w,d-w+1,D,_-D+1)]}else{S=new a,P=s,M=u,L=p[0]-g[0]-l,A=Number.MAX_VALUE,N=v?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do b=L+o,b===P||b<M&&f[b-1]>=f[b+1]?(h=f[b+1]-1,m=h-L-l,h>A&&S.MarkNextChange(),A=h+1,S.AddOriginalElement(h+1,m+1),L=b+1-o):(h=f[b-1],m=h-L-l,h>A&&S.MarkNextChange(),A=h,S.AddModifiedElement(h+1,m+1),L=b-1-o),N>=0&&(f=this.m_reverseHistory[N],o=f[0],P=1,M=f.length-1);while(--N>=-1);E=S.getChanges()}return this.ConcatenateChanges(C,E)},e.prototype.ComputeRecursionPoint=function(e,t,r,i,o,a,l){var c,f,h,d=0,p=0,m=0,_=0;e--,r--,o[0]=0,a[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var g=t-e+(i-r),v=g+1,y=new Array(v),b=new Array(v),C=i-r,E=t-e,S=e-r,P=t-i,M=E-C,L=M%2===0;y[C]=e,b[E]=t,l[0]=!1;var A,N;for(h=1;h<=g/2+1;h++){var w=0,D=0;for(d=this.ClipDiagonalBound(C-h,h,C,v),p=this.ClipDiagonalBound(C+h,h,C,v),A=d;A<=p;A+=2){for(c=A===d||A<p&&y[A-1]<y[A+1]?y[A+1]:y[A-1]+1,f=c-(A-C)-S,N=c;c<t&&f<i&&this.ElementsAreEqual(c+1,f+1);)c++,f++;if(y[A]=c,c+f>w+D&&(w=c,D=f),!L&&Math.abs(A-E)<=h-1&&c>=b[A])return o[0]=c,a[0]=f,N<=b[A]&&u>0&&h<=u+1?this.WALKTRACE(C,d,p,S,E,m,_,P,y,b,c,t,o,f,i,a,L,l):null}var k=(w-e+(D-r)-h)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(w,this.OriginalSequence,k))return l[0]=!0,o[0]=w,a[0]=D,k>0&&u>0&&h<=u+1?this.WALKTRACE(C,d,p,S,E,m,_,P,y,b,c,t,o,f,i,a,L,l):(e++,r++,[new n.DiffChange(e,t-e+1,r,i-r+1)]);for(m=this.ClipDiagonalBound(E-h,h,E,v),_=this.ClipDiagonalBound(E+h,h,E,v),A=m;A<=_;A+=2){for(c=A===m||A<_&&b[A-1]>=b[A+1]?b[A+1]-1:b[A-1],f=c-(A-E)-P,N=c;c>e&&f>r&&this.ElementsAreEqual(c,f);)c--,f--;if(b[A]=c,L&&Math.abs(A-C)<=h&&c<=y[A])return o[0]=c,a[0]=f,N>=y[A]&&u>0&&h<=u+1?this.WALKTRACE(C,d,p,S,E,m,_,P,y,b,c,t,o,f,i,a,L,l):null}if(h<=u){var x=new Array(p-d+2);x[0]=C-d+1,s.Copy(y,d,x,1,p-d+1),this.m_forwardHistory.push(x),x=new Array(_-m+2),x[0]=E-m+1,s.Copy(b,m,x,1,_-m+1),this.m_reverseHistory.push(x)}}return this.WALKTRACE(C,d,p,S,E,m,_,P,y,b,c,t,o,f,i,a,L,l)},e.prototype.ConcatenateChanges=function(e,t){var n=[],r=null;return 0===e.length||0===t.length?t.length>0?t:e:this.ChangesOverlap(e[e.length-1],t[0],n)?(r=new Array(e.length+t.length-1),s.Copy(e,0,r,0,e.length-1),r[e.length-1]=n[0],s.Copy(t,1,r,e.length,t.length-1),r):(r=new Array(e.length+t.length),s.Copy(e,0,r,0,e.length),s.Copy(t,0,r,e.length,t.length),r)},e.prototype.ChangesOverlap=function(e,t,r){if(o.Assert(e.originalStart<=t.originalStart,"Left change is not less than or equal to right change"),o.Assert(e.modifiedStart<=t.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=t.originalStart||e.modifiedStart+e.modifiedLength>=t.modifiedStart){var i=e.originalStart,s=e.originalLength,u=e.modifiedStart,a=e.modifiedLength;return e.originalStart+e.originalLength>=t.originalStart&&(s=t.originalStart+t.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=t.modifiedStart&&(a=t.modifiedStart+t.modifiedLength-e.modifiedStart),r[0]=new n.DiffChange(i,s,u,a),!0}return r[0]=null,!1},e.prototype.ClipDiagonalBound=function(e,t,n,r){if(e>=0&&e<r)return e;var i=n,o=r-n-1,s=t%2===0;if(e<0){var u=i%2===0;return s===u?0:1}var a=o%2===0;return s===a?r-1:r-2},e}();t.LcsDiff=c}),e(n[21],r([0,1]),function(e,t){"use strict";function n(e,t){var n=[];e(n);for(var r={},o=0,s=n.length;o<s;o++)n[o]&&(r[n[o]]=o);t(r);var u={};for(var a in r)r.hasOwnProperty(a)&&(u[a]=r[a],u[a.toLowerCase()]=r[a]);return new i(n,u)}function r(e,t){return e|(65535&t)<<16}!function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.MAX_VALUE=109]="MAX_VALUE"}(t.KeyCode||(t.KeyCode={}));var i=(t.KeyCode,function(){function e(e,t){this._fromKeyCode=e,this._toKeyCode=t}return e.prototype.fromKeyCode=function(e){return this._fromKeyCode[e]},e.prototype.toKeyCode=function(e){return this._toKeyCode.hasOwnProperty(e)?this._toKeyCode[e]:0},e}());t.Mapping=i;var o=n(function(e){e[0]="unknown",e[1]="Backspace",e[2]="Tab",e[3]="Enter",e[4]="Shift",e[5]="Ctrl",e[6]="Alt",e[7]="PauseBreak",e[8]="CapsLock",e[9]="Escape",e[10]="Space",e[11]="PageUp",e[12]="PageDown",e[13]="End",e[14]="Home",e[15]="LeftArrow",e[16]="UpArrow",e[17]="RightArrow",e[18]="DownArrow",e[19]="Insert",e[20]="Delete",e[21]="0",e[22]="1",e[23]="2",e[24]="3",e[25]="4",e[26]="5",e[27]="6",e[28]="7",e[29]="8",e[30]="9",e[31]="A",e[32]="B",e[33]="C",e[34]="D",e[35]="E",e[36]="F",e[37]="G",e[38]="H",e[39]="I",e[40]="J",e[41]="K",e[42]="L",e[43]="M",e[44]="N",e[45]="O",e[46]="P",e[47]="Q",e[48]="R",e[49]="S",e[50]="T",e[51]="U",e[52]="V",e[53]="W",e[54]="X",e[55]="Y",e[56]="Z",e[58]="ContextMenu",e[59]="F1",e[60]="F2",e[61]="F3",e[62]="F4",e[63]="F5",e[64]="F6",e[65]="F7",e[66]="F8",e[67]="F9",e[68]="F10",e[69]="F11",e[70]="F12",e[71]="F13",e[72]="F14",e[73]="F15",e[74]="F16",e[75]="F17",e[76]="F18",e[77]="F19",e[78]="NumLock",e[79]="ScrollLock",e[80]=";",e[81]="=",e[82]=",",e[83]="-",e[84]=".",e[85]="/",e[86]="`",e[87]="[",e[88]="\\",e[89]="]",e[90]="'",e[91]="OEM_8",e[92]="OEM_102",e[93]="NumPad0",e[94]="NumPad1",e[95]="NumPad2",e[96]="NumPad3",e[97]="NumPad4",e[98]="NumPad5",e[99]="NumPad6",e[100]="NumPad7",e[101]="NumPad8",e[102]="NumPad9",e[103]="NumPad_Multiply",e[104]="NumPad_Add",e[105]="NumPad_Separator",e[106]="NumPad_Subtract",e[107]="NumPad_Decimal",e[108]="NumPad_Divide"},function(e){e["\r"]=3});t.USER_SETTINGS=n(function(e){for(var t=0,n=o._fromKeyCode.length;t<n;t++)e[t]=o._fromKeyCode[t];e[15]="Left",e[16]="Up",e[17]="Right",e[18]="Down"},function(e){e.OEM_1=80,e.OEM_PLUS=81,e.OEM_COMMA=82,e.OEM_MINUS=83,e.OEM_PERIOD=84,e.OEM_2=85,e.OEM_3=86,e.OEM_4=87,e.OEM_5=88,e.OEM_6=89,e.OEM_7=90,e.OEM_8=91,e.OEM_102=92});var s;!function(e){function t(e){return o.fromKeyCode(e)}function n(e){return o.toKeyCode(e)}e.toString=t,e.fromString=n}(s=t.KeyCodeUtils||(t.KeyCodeUtils={}));var u;!function(e){e[e.CtrlCmd=32768]="CtrlCmd",e[e.Shift=16384]="Shift",e[e.Alt=8192]="Alt",e[e.WinCtrl=4096]="WinCtrl",e[e.KeyCode=4095]="KeyCode"}(u||(u={})),function(e){e[e.CtrlCmd=32768]="CtrlCmd",e[e.Shift=16384]="Shift",e[e.Alt=8192]="Alt",e[e.WinCtrl=4096]="WinCtrl"}(t.KeyMod||(t.KeyMod={}));t.KeyMod;t.KeyChord=r;var a=function(){function e(){}return e.extractFirstPart=function(e){return 65535&e},e.extractChordPart=function(e){return e>>16&65535},e.hasChord=function(e){return 0!==this.extractChordPart(e)},e.hasCtrlCmd=function(e){return!!(32768&e)},e.hasShift=function(e){return!!(16384&e)},e.hasAlt=function(e){return!!(8192&e)},e.hasWinCtrl=function(e){return!!(4096&e)},e.extractKeyCode=function(e){return 4095&e},e}();t.BinaryKeybindings=a});var o=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};e(n[12],r([0,1]),function(e,t){"use strict";var n=function(){function e(){this.map=Object.create(null),this._size=0}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.get=function(e){var t=this.peek(e);return t?t:null},e.prototype.getOrSet=function(e,t){var n=this.get(e);return n?n:(this.set(e,t),t)},e.prototype.keys=function(){var e=[];for(var t in this.map)e.push(this.map[t].key);return e},e.prototype.values=function(){var e=[];for(var t in this.map)e.push(this.map[t].value);return e},e.prototype.entries=function(){var e=[];for(var t in this.map)e.push(this.map[t]);return e},e.prototype.set=function(e,t){return!this.get(e)&&(this.push(e,t),!0)},e.prototype.delete=function(e){var t=this.get(e);return t?(this.pop(e),t):null},e.prototype.has=function(e){return!!this.get(e)},e.prototype.clear=function(){this.map=Object.create(null),this._size=0},e.prototype.push=function(e,t){var n={key:e,value:t};this.map[e.toString()]=n,this._size++},e.prototype.pop=function(e){delete this.map[e.toString()],this._size--},e.prototype.peek=function(e){var t=this.map[e.toString()];return t?t.value:null},e}();t.LinkedMap=n;var r=function(){function e(e,t){void 0===e&&(e=Number.MAX_VALUE),void 0===t&&(t=1),this.limit=e,this.map=Object.create(null),this._size=0,this.ratio=e*t}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.set=function(e,t){if(this.map[e])return!1;var n={key:e,value:t};return this.push(n),this._size>this.limit&&this.trim(),!0},e.prototype.get=function(e){var t=this.map[e];return t?t.value:null},e.prototype.getOrSet=function(e,t){var n=this.get(e);return n?n:(this.set(e,t),t)},e.prototype.delete=function(e){var t=this.map[e];return t?(this.map[e]=void 0,this._size--,t.next?t.next.prev=t.prev:this.head=t.prev,t.prev?t.prev.next=t.next:this.tail=t.next,t.value):null},e.prototype.has=function(e){return!!this.map[e]},e.prototype.clear=function(){this.map=Object.create(null),this._size=0,this.head=null,this.tail=null},e.prototype.push=function(e){this.head&&(e.prev=this.head,this.head.next=e),this.tail||(this.tail=e),this.head=e,this.map[e.key]=e,this._size++},e.prototype.trim=function(){if(this.tail)if(this.ratio<this.limit)for(var e=0,t=this.tail;t.next;){if(this.map[t.key]=void 0,this._size--,e===this.ratio){this.tail=t.next,this.tail.prev=null;break}t=t.next,e++}else this.map[this.tail.key]=void 0,this._size--,this.tail=this.tail.next,this.tail.prev=null},e}();t.BoundedLinkedMap=r;var i=function(e){function t(t){e.call(this,t)}return o(t,e),t.prototype.get=function(e){var t=this.map[e];return t?(this.delete(e),this.push(t),t.value):null},t}(r);t.LRUCache=i}),e(n[5],r([0,1]),function(e,t){"use strict";function n(){return"undefined"!=typeof g.Worker}var r=!1,i=!1,o=!1,s=!1,u=!1,a=!1,l=!1,c=void 0,f=void 0;if(t.LANGUAGE_DEFAULT="en","object"==typeof process){r="win32"===process.platform,i="darwin"===process.platform,o="linux"===process.platform,s=!r&&0===process.getuid();var h=process.env.VSCODE_NLS_CONFIG;if(h)try{var d=JSON.parse(h),p=d.availableLanguages["*"];c=d.locale,f=p?p:t.LANGUAGE_DEFAULT}catch(e){}u=!0}else if("object"==typeof navigator){var m=navigator.userAgent;r=m.indexOf("Windows")>=0,i=m.indexOf("Macintosh")>=0,o=m.indexOf("Linux")>=0,a=!0,c=navigator.language,f=c,l=!!self.QUnit}!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={}));var _=t.Platform;t._platform=_.Web,u&&(i?t._platform=_.Mac:r?t._platform=_.Windows:o&&(t._platform=_.Linux)),t.isWindows=r,t.isMacintosh=i,t.isLinux=o,t.isRootUser=s,t.isNative=u,t.isWeb=a,t.isQunit=l,t.platform=t._platform,t.language=f,t.locale=c;var g="object"==typeof self?self:global;t.globals=g,t.hasWebWorkerSupport=n,t.setTimeout=g.setTimeout.bind(g),t.clearTimeout=g.clearTimeout.bind(g),t.setInterval=g.setInterval.bind(g),t.clearInterval=g.clearInterval.bind(g)}),e(n[8],r([0,1,12]),function(e,t,n){"use strict";function r(e,t,n){void 0===n&&(n="0");for(var r=""+e,i=[r],o=r.length;o<t;o++)i.push(n);return i.reverse().join("")}function i(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return 0===t.length?e:e.replace(I,function(e,n){var r=parseInt(n,10);return isNaN(r)||r<0||r>=t.length?e:t[r]})}function o(e){return e.replace(/[<|>|&]/g,function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}})}function s(e){return e.replace(/[\-\\\{\}\*\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&")}function u(e,t){void 0===t&&(t=" ");var n=a(e,t);return l(n,t)}function a(e,t){if(!e||!t)return e;var n=t.length;if(0===n||0===e.length)return e;for(var r=0,i=-1;(i=e.indexOf(t,r))===r;)r+=n;return e.substring(r)}function l(e,t){if(!e||!t)return e;var n=t.length,r=e.length;if(0===n||0===r)return e;for(var i=r,o=-1;;){if(o=e.lastIndexOf(t,i-1),o===-1||o+n!==i)break;if(0===o)return"";i=o}return e.substring(0,i)}function c(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function f(e){return e.replace(/\*/g,"")}function h(e,t){if(e.length<t.length)return!1;for(var n=0;n<t.length;n++)if(e[n]!==t[n])return!1;return!0}function d(e,t){var n=e.length-t.length;return n>0?e.indexOf(t,n)===n:0===n&&e===t}function p(e,t,n){if(void 0===n&&(n={}),""===e)throw new Error("Cannot create regex from empty string");t||(e=e.replace(/[\-\\\{\}\*\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&")),n.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));var r="";return n.global&&(r+="g"),n.matchCase||(r+="i"),n.multiline&&(r+="m"),new RegExp(e,r)}function m(e){if("^"===e.source||"^$"===e.source||"$"===e.source)return!1;var t=e.exec("");return t&&0===e.lastIndex}function _(e){if(!t.canNormalize||!e)return e;var n=K.get(e);if(n)return n;var r;return r=R.test(e)?e.normalize("NFC"):e,K.set(e,r),r}function g(e){for(var t=0,n=e.length;t<n;t++){var r=e.charCodeAt(t);if(32!==r&&9!==r)return t}return-1}function v(e){for(var t=0,n=e.length;t<n;t++){var r=e.charCodeAt(t);if(32!==r&&9!==r)return e.substring(0,t)}return e}function y(e,t){void 0===t&&(t=e.length-1);for(var n=t;n>=0;n--){var r=e.charCodeAt(n);if(32!==r&&9!==r)return n}return-1}function b(e,t){return e<t?-1:e>t?1:0}function C(e){return e>=97&&e<=122||e>=65&&e<=90}function E(e,t){var n=e.length,r=t.length;if(n!==r)return!1;for(var i=0;i<n;i++){var o=e.charCodeAt(i),s=t.charCodeAt(i);if(o!==s)if(C(o)&&C(s)){var u=Math.abs(o-s);if(0!==u&&32!==u)return!1}else if(String.fromCharCode(o).toLocaleLowerCase()!==String.fromCharCode(s).toLocaleLowerCase())return!1}return!0}function S(e,t){var n,r=Math.min(e.length,t.length);for(n=0;n<r;n++)if(e.charCodeAt(n)!==t.charCodeAt(n))return n;return r}function P(e,t){var n,r=Math.min(e.length,t.length),i=e.length-1,o=t.length-1;for(n=0;n<r;n++)if(e.charCodeAt(i-n)!==t.charCodeAt(o-n))return n;return r}function M(e){return 55296<=e&&e<=56319}function L(e){return 56320<=e&&e<=57343}function A(e){return e=+e,e>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}function N(e,t,n){void 0===n&&(n=4);var r=Math.abs(e.length-t.length);if(r>n)return 0;var i,o,s=[],u=[];for(i=0;i<t.length+1;++i)u.push(0);for(i=0;i<e.length+1;++i)s.push(u);for(i=1;i<e.length+1;++i)for(o=1;o<t.length+1;++o)e[i-1]===t[o-1]?s[i][o]=s[i-1][o-1]+1:s[i][o]=Math.max(s[i-1][o],s[i][o-1]);return s[e.length][t.length]-Math.sqrt(r)}function w(e){for(var t,n=/\r\n|\r|\n/g,r=[0];t=n.exec(e);)r.push(n.lastIndex);return r}function D(e,n){if(e.length<n)return e;for(var r=e.split(/\b/),i=0,o=r.length-1;o>=0;o--)if(i+=r[o].length,i>n){r.splice(0,o);break}return r.join(t.empty).replace(/^\s/,t.empty)}function k(e){return e&&(e=e.replace(F,""),e=e.replace(q,"\n"),e=e.replace(W,""),e=e.replace(Y,"")),e}function x(e){return e&&e.length>0&&65279===e.charCodeAt(0)}function T(e,t,n){var r=e.length+t.length;return r>n&&(e="..."+e.substr(r-n)),e+=t.length>n?t.substr(t.length-n):t}function U(e){return btoa(encodeURIComponent(e))}function O(e,t){for(var n="",r=0;r<t;r++)n+=e;return n}t.empty="",t.pad=r;var I=/{(\d+)}/g;t.format=i,t.escape=o,t.escapeRegExpCharacters=s,t.trim=u,t.ltrim=a,t.rtrim=l,t.convertSimple2RegExpPattern=c,t.stripWildcards=f,t.startsWith=h,t.endsWith=d,t.createRegExp=p,t.regExpLeadsToEndlessLoop=m,t.canNormalize="function"==typeof"".normalize;var R=/[^\u0000-\u0080]/,K=new n.BoundedLinkedMap(1e4);t.normalizeNFC=_,t.firstNonWhitespaceIndex=g,t.getLeadingWhitespace=v,t.lastNonWhitespaceIndex=y,t.compare=b,t.equalsIgnoreCase=E,t.commonPrefixLength=S,t.commonSuffixLength=P,t.isHighSurrogate=M,t.isLowSurrogate=L,t.isFullWidthCharacter=A,t.difference=N,t.computeLineStarts=w,t.lcut=D;var F=/\x1B\x5B[12]?K/g,q=/\xA/g,W=/\x1b\[\d+m/g,Y=/\x1b\[0?m/g;t.removeAnsiEscapeCodes=k,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=x,t.appendWithLimit=T,t.safeBtoa=U,t.repeat=O}),e(n[22],r([0,1,8,12]),function(e,t,n,r){"use strict";function i(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,n){for(var r=0,i=e.length;r<i;r++){var o=e[r](t,n);if(o)return o}return null}}function o(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,n){for(var r=[],i=0,o=e.length;i<o;i++){var s=e[i](t,n);if(!s)return null;r=r.concat(s)}return r}}function s(e,t,n){if(!n||0===n.length||n.length<t.length)return null;e&&(t=t.toLowerCase(),n=n.toLowerCase());for(var r=0;r<t.length;r++)if(t[r]!==n[r])return null;return t.length>0?[{start:0,end:t.length}]:[]}function u(e,t){var n=t.toLowerCase().indexOf(e.toLowerCase());return n===-1?null:[{start:n,end:n+e.length}]}function a(e,t){return l(e.toLowerCase(),t.toLowerCase(),0,0)}function l(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]===t[r]){var i=null;if(i=l(e,t,n+1,r+1))return m({start:r,end:r+1},i)}return l(e,t,n,r+1)}function c(e){return 97<=e&&e<=122}function f(e){return 65<=e&&e<=90}function h(e){return 48<=e&&e<=57}function d(e){return 32===e||9===e||10===e||13===e}function p(e){return c(e)||f(e)||h(e)}function m(e,t){return 0===t.length?t=[e]:e.end===t[0].start?t[0].start=e.start:t.unshift(e),t}function _(e,t){for(var n=t;n<e.length;n++){var r=e.charCodeAt(n);if(f(r)||h(r)||n>0&&!p(e.charCodeAt(n-1)))return n}return e.length}function g(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]!==t[r].toLowerCase())return null;var i=null,o=r+1;for(i=g(e,t,n+1,r+1);!i&&(o=_(t,o))<t.length;)i=g(e,t,n+1,o),o++;return null===i?null:m({start:r,end:r+1},i)}function v(e){if(e.length>60)return!1;for(var t=0,n=0,r=0,i=0,o=0,s=0;s<e.length;s++)o=e.charCodeAt(s),f(o)&&t++,c(o)&&n++,p(o)&&r++,h(o)&&i++;var u=t/e.length,a=n/e.length,l=r/e.length,d=i/e.length;return a>.2&&u<.8&&l>.6&&d<.2}function y(e){for(var t=0,n=0,r=0,i=0,o=0;o<e.length;o++)r=e.charCodeAt(o),f(r)&&t++,c(r)&&n++,d(r)&&i++;return 0!==t&&0!==n||0!==i?t<=5:e.length<=30}function b(e,t){if(!t||0===t.length)return null;if(!y(e))return null;if(!v(t))return null;for(var n=null,r=0;r<t.length&&null===(n=g(e.toLowerCase(),t,0,r));)r=_(t,r+1);return n}function C(e,t){if(!t||0===t.length)return null;for(var n=null,r=0;r<t.length&&null===(n=E(e.toLowerCase(),t,0,r));)r=S(t,r+1);return n}function E(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]!==t[r].toLowerCase())return null;var i=null,o=r+1;for(i=E(e,t,n+1,r+1);!i&&(o=S(t,o))<t.length;)i=E(e,t,n+1,o),o++;return null===i?null:m({start:r,end:r+1},i)}function S(e,t){for(var n=t;n<e.length;n++){var r=e.charCodeAt(n);if(d(r)||n>0&&d(e.charCodeAt(n-1)))return n}return e.length}function P(e,r,i){if(void 0===i&&(i=!1),"string"!=typeof e||"string"!=typeof r)return null;var o=L.get(e);o||(o=new RegExp(n.convertSimple2RegExpPattern(e),"i"),L.set(e,o));var s=o.exec(r);return s?[{start:s.index,end:s.index+s[0].length}]:i?M(e,r):t.fuzzyContiguousFilter(e,r)}t.or=i,t.and=o,t.matchesStrictPrefix=function(e,t){return s(!1,e,t)},t.matchesPrefix=function(e,t){return s(!0,e,t)},t.matchesContiguousSubString=u,t.matchesSubString=a,t.matchesCamelCase=b,t.matchesWords=C,function(e){e[e.Contiguous=0]="Contiguous",e[e.Separate=1]="Separate"}(t.SubstringMatching||(t.SubstringMatching={}));t.SubstringMatching;t.fuzzyContiguousFilter=i(t.matchesPrefix,b,u);var M=i(t.matchesPrefix,b,a),L=new r.BoundedLinkedMap(1e4);t.matchesFuzzy=P}),e(n[7],r([0,1]),function(e,t){"use strict";function n(e){return Array.isArray?Array.isArray(e):!(!e||typeof e.length!==_.number||e.constructor!==Array)}function r(e){return typeof e===_.string||e instanceof String}function i(e){return n(e)&&e.every(function(e){return r(e)})}function o(e){return!(typeof e!==_.object||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)}function s(e){return(typeof e===_.number||e instanceof Number)&&!isNaN(e)}function u(e){return e===!0||e===!1}function a(e){return typeof e===_.undefined}function l(e){return a(e)||null===e}function c(e){if(!o(e))return!1;for(var t in e)if(g.call(e,t))return!1;return!0}function f(e){return typeof e===_.function}function h(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return e&&e.length>0&&e.every(f)}function d(e,t){for(var n=Math.min(e.length,t.length),r=0;r<n;r++)p(e[r],t[r])}function p(e,t){if(r(t)){if(typeof e!==t)throw new Error("argument does not match constraint: typeof "+t)}else if(f(t)){if(e instanceof t)return;if(e&&e.constructor===t)return;if(1===t.length&&t.call(void 0,e)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function m(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=Object.create(e.prototype);return e.apply(r,t),r}var _={number:"number",string:"string",undefined:"undefined",object:"object",function:"function"};t.isArray=n,t.isString=r,t.isStringArray=i,t.isObject=o,t.isNumber=s,t.isBoolean=u,t.isUndefined=a,t.isUndefinedOrNull=l;var g=Object.prototype.hasOwnProperty;t.isEmptyObject=c,t.isFunction=f,t.areFunctions=h,t.validateConstraints=d,t.validateConstraint=p,t.create=m}),e(n[3],r([0,1,5,7]),function(e,t,n,r){"use strict";function i(e){t.errorHandler.setUnexpectedErrorHandler(e)}function o(e){a(e)||t.errorHandler.onUnexpectedError(e)}function s(e){return e.then(null,o)}function u(e){if(e instanceof Error){var t=e.name,n=e.message,r=e.stacktrace||e.stack;return{$isError:!0,name:t,message:n,stack:r}}return e}function a(e){return e instanceof Error&&e.name===g&&e.message===g}function l(){var e=new Error(g);return e.name=e.message,e}function c(){return new Error("Not Implemented")}function f(e){return e?new Error("Illegal argument: "+e):new Error("Illegal argument")}function h(e){return e?new Error("Illegal state: "+e):new Error("Illegal state")}function d(e){return e?new Error("readonly property '"+e+" cannot be changed'"):new Error("readonly property cannot be changed")}function p(e,t){void 0===t&&(t={});var n=new Error(e);return r.isNumber(t.severity)&&(n.severity=t.severity),t.actions&&(n.actions=t.actions),n}function m(e){return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"}var _=function(){function e(){this.listeners=[],this.unexpectedErrorHandler=function(e){n.setTimeout(function(){if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}return e.prototype.addListener=function(e){var t=this;return this.listeners.push(e),function(){t._removeListener(e)}},e.prototype.emit=function(e){this.listeners.forEach(function(t){t(e)})},e.prototype._removeListener=function(e){this.listeners.splice(this.listeners.indexOf(e),1)},e.prototype.setUnexpectedErrorHandler=function(e){this.unexpectedErrorHandler=e},e.prototype.getUnexpectedErrorHandler=function(){return this.unexpectedErrorHandler},e.prototype.onUnexpectedError=function(e){this.unexpectedErrorHandler(e),this.emit(e)},e}();t.ErrorHandler=_,t.errorHandler=new _,t.setUnexpectedErrorHandler=i,t.onUnexpectedError=o,t.onUnexpectedPromiseError=s,t.transformErrorForSerialization=u;var g="Canceled";t.isPromiseCanceledError=a,t.canceled=l,t.notImplemented=c,t.illegalArgument=f,t.illegalState=h,t.readonly=d,t.create=p,t.getErrorMessage=m}),e(n[16],r([0,1,3]),function(e,t,n){"use strict";var r=function(){function e(){}return e.prototype.add=function(e,t,n){var r=this;void 0===t&&(t=null),this._callbacks||(this._callbacks=[],this._contexts=[]),this._callbacks.push(e),this._contexts.push(t),Array.isArray(n)&&n.push({dispose:function(){return r.remove(e,t)}})},e.prototype.remove=function(e,t){if(void 0===t&&(t=null),this._callbacks){for(var n=!1,r=0,i=this._callbacks.length;r<i;r++)if(this._callbacks[r]===e){if(this._contexts[r]===t)return this._callbacks.splice(r,1),void this._contexts.splice(r,1);n=!0}if(n)throw new Error("When adding a listener with a context, you should remove it with the same context")}},e.prototype.invoke=function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];if(this._callbacks){for(var r=[],i=this._callbacks.slice(0),o=this._contexts.slice(0),s=0,u=i.length;s<u;s++)try{
r.push(i[s].apply(o[s],e))}catch(e){n.onUnexpectedError(e)}return r}},e.prototype.isEmpty=function(){return!this._callbacks||0===this._callbacks.length},e.prototype.entries=function(){var e=this;return this._callbacks?this._callbacks.map(function(t,n){return[t,e._contexts[n]]}):[]},e.prototype.dispose=function(){this._callbacks=void 0,this._contexts=void 0},e}();Object.defineProperty(t,"__esModule",{value:!0}),t.default=r}),e(n[6],r([0,1,7]),function(e,t,n){"use strict";function r(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];var r=e[0];return n.isArray(r)&&(e=r),e.forEach(function(e){return e&&e.dispose()}),[]}function i(e){return{dispose:function(){return r(e)}}}function s(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return i(e.map(function(e){return{dispose:e}}))}t.empty=Object.freeze({dispose:function(){}}),t.dispose=r,t.combinedDisposable=i,t.toDisposable=s;var u=function(){function e(){this._toDispose=[]}return e.prototype.dispose=function(){this._toDispose=r(this._toDispose)},e.prototype._register=function(e){return this._toDispose.push(e),e},e}();t.Disposable=u;var a=function(e){function t(){e.apply(this,arguments)}return o(t,e),t.prototype.add=function(e){if(!Array.isArray(e))return this._register(e);for(var t=0,n=e;t<n.length;t++){var r=n[t];return this._register(r)}},t}(u);t.Disposables=a}),e(n[9],r([0,1,6,16]),function(e,t,n,r){"use strict";function i(e,t){return function(n,r,i){var o=e.addListener2(t,function(){n.apply(r,arguments)});return Array.isArray(i)&&i.push(o),o}}function o(e){var t=new _,n=!1;return e.then(null,function(){return null}).then(function(){n?t.fire():setTimeout(function(){return t.fire()},0)}),n=!0,t.event}function s(e){var t=null,n=null,r=new _({onFirstListenerAdd:function(){t=e.then(function(e){return n=e(function(e){return r.fire(e)})},function(){return null})},onLastListenerRemove:function(){t&&(t.cancel(),t=null),n&&(n.dispose(),n=null)}});return r.event}function u(e){return function(t,n,r){void 0===n&&(n=null);var i=e(function(e){return i.dispose(),t.call(n,e)},null,r);return i}}function a(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];var r=[],i=new _({onFirstListenerAdd:function(){r=e.map(function(e){return e(function(e){return i.fire(e)})})},onLastListenerRemove:function(){r=n.dispose(r)}});return i.event}function l(e,t,n){void 0===n&&(n=100);var r,i,o,s=new _({onFirstListenerAdd:function(){r=e(function(e){i=t(i,e),clearTimeout(o),o=setTimeout(function(){var e=i;i=void 0,s.fire(e)},n)})},onLastListenerRemove:function(){r.dispose()}});return s.event}function c(e,t){return function(n,r,i){return void 0===r&&(r=null),e(function(e){return n.call(r,t(e))},null,i)}}function f(e,t){return function(n,r,i){return void 0===r&&(r=null),e(function(e){return t(e)&&n.call(r,e)},null,i)}}function h(e){return new v(e)}function d(e){var t=(new Date).getTime();return c(u(e),function(e){return(new Date).getTime()-t})}function p(e,t,n){void 0===t&&(t=!1),void 0===n&&(n=[]),n=n.slice();var r=e(function(e){n?n.push(e):o.fire(e)}),i=function(){n.forEach(function(e){return o.fire(e)}),n=null},o=new _({onFirstListenerAdd:function(){r||(r=e(function(e){return o.fire(e)}))},onFirstListenerDidAdd:function(){n&&(t?setTimeout(i):i())},onLastListenerRemove:function(){r.dispose(),r=null}});return o.event}var m;!function(e){var t={dispose:function(){}};e.None=function(){return t}}(m||(m={})),Object.defineProperty(t,"__esModule",{value:!0}),t.default=m;var _=function(){function e(e){this._options=e}return Object.defineProperty(e.prototype,"event",{get:function(){var t=this;return this._event||(this._event=function(n,i,o){t._callbacks||(t._callbacks=new r.default);var s=t._callbacks.isEmpty();s&&t._options&&t._options.onFirstListenerAdd&&t._options.onFirstListenerAdd(t),t._callbacks.add(n,i),s&&t._options&&t._options.onFirstListenerDidAdd&&t._options.onFirstListenerDidAdd(t);var u;return u={dispose:function(){u.dispose=e._noop,t._disposed||(t._callbacks.remove(n,i),t._options&&t._options.onLastListenerRemove&&t._callbacks.isEmpty()&&t._options.onLastListenerRemove(t))}},Array.isArray(o)&&o.push(u),u}),this._event},enumerable:!0,configurable:!0}),e.prototype.fire=function(e){this._callbacks&&this._callbacks.invoke.call(this._callbacks,e)},e.prototype.dispose=function(){this._callbacks&&(this._callbacks.dispose(),this._callbacks=void 0,this._disposed=!0)},e._noop=function(){},e}();t.Emitter=_,t.fromEventEmitter=i,t.fromPromise=o,t.delayed=s,t.once=u,t.any=a,t.debounceEvent=l;var g=function(){function e(){this.buffers=[]}return e.prototype.wrapEvent=function(e){var t=this;return function(n,r,i){return e(function(e){var i=t.buffers[t.buffers.length-1];i?i.push(function(){return n.call(r,e)}):n.call(r,e)},void 0,i)}},e.prototype.bufferEvents=function(e){var t=[];this.buffers.push(t),e(),this.buffers.pop(),t.forEach(function(e){return e()})},e}();t.EventBufferer=g,t.mapEvent=c,t.filterEvent=f;var v=function(){function e(e){this._event=e}return Object.defineProperty(e.prototype,"event",{get:function(){return this._event},enumerable:!0,configurable:!0}),e.prototype.map=function(t){return new e(c(this._event,t))},e.prototype.filter=function(t){return new e(f(this._event,t))},e.prototype.on=function(e,t,n){return this._event(e,t,n)},e}();t.chain=h,t.stopwatch=d,t.buffer=p}),e(n[10],r([0,1,9]),function(e,t,n){"use strict";var r,i=Object.freeze(function(e,t){var n=setTimeout(e.bind(t),0);return{dispose:function(){clearTimeout(n)}}});!function(e){e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.default.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})}(r=t.CancellationToken||(t.CancellationToken={}));var o=function(){function e(){this._isCancelled=!1}return e.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this._emitter=void 0))},Object.defineProperty(e.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onCancellationRequested",{get:function(){return this._isCancelled?i:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)},enumerable:!0,configurable:!0}),e}(),s=function(){function e(){}return Object.defineProperty(e.prototype,"token",{get:function(){return this._token||(this._token=new o),this._token},enumerable:!0,configurable:!0}),e.prototype.cancel=function(){this._token?this._token.cancel():this._token=r.Cancelled},e.prototype.dispose=function(){this.cancel()},e}();t.CancellationTokenSource=s}),e(n[11],r([0,1,5]),function(e,t,n){"use strict";function r(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()}function i(e){return encodeURIComponent(e).replace(/[!'()*]/g,r)}function o(e){return e}var s=function(){function e(){this._scheme=e._empty,this._authority=e._empty,this._path=e._empty,this._query=e._empty,this._fragment=e._empty,this._formatted=null,this._fsPath=null}return e.isUri=function(t){return t instanceof e||!!t&&("string"==typeof t.authority&&"string"==typeof t.fragment&&"string"==typeof t.path&&"string"==typeof t.query&&"string"==typeof t.scheme)},Object.defineProperty(e.prototype,"scheme",{get:function(){return this._scheme},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"authority",{get:function(){return this._authority},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"path",{get:function(){return this._path},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"query",{get:function(){return this._query},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fragment",{get:function(){return this._fragment},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fsPath",{get:function(){if(!this._fsPath){var t;t=this._authority&&this._path&&"file"===this.scheme?"//"+this._authority+this._path:e._driveLetterPath.test(this._path)?this._path[1].toLowerCase()+this._path.substr(2):this._path,n.isWindows&&(t=t.replace(/\//g,"\\")),this._fsPath=t}return this._fsPath},enumerable:!0,configurable:!0}),e.prototype.with=function(t){if(!t)return this;var n=t.scheme,r=t.authority,i=t.path,o=t.query,s=t.fragment;if(void 0===n?n=this.scheme:null===n&&(n=""),void 0===r?r=this.authority:null===r&&(r=""),void 0===i?i=this.path:null===i&&(i=""),void 0===o?o=this.query:null===o&&(o=""),void 0===s?s=this.fragment:null===s&&(s=""),n===this.scheme&&r===this.authority&&i===this.path&&o===this.query&&s===this.fragment)return this;var u=new e;return u._scheme=n,u._authority=r,u._path=i,u._query=o,u._fragment=s,e._validate(u),u},e.parse=function(t){var n=new e,r=e._parseComponents(t);return n._scheme=r.scheme,n._authority=decodeURIComponent(r.authority),n._path=decodeURIComponent(r.path),n._query=decodeURIComponent(r.query),n._fragment=decodeURIComponent(r.fragment),e._validate(n),n},e.file=function(t){var n=new e;if(n._scheme="file",t=t.replace(/\\/g,e._slash),t[0]===e._slash&&t[0]===t[1]){var r=t.indexOf(e._slash,2);r===-1?n._authority=t.substring(2):(n._authority=t.substring(2,r),n._path=t.substring(r))}else n._path=t;return n._path[0]!==e._slash&&(n._path=e._slash+n._path),e._validate(n),n},e._parseComponents=function(t){var n={scheme:e._empty,authority:e._empty,path:e._empty,query:e._empty,fragment:e._empty},r=e._regexp.exec(t);return r&&(n.scheme=r[2]||n.scheme,n.authority=r[4]||n.authority,n.path=r[5]||n.path,n.query=r[7]||n.query,n.fragment=r[9]||n.fragment),n},e.from=function(t){return(new e).with(t)},e._validate=function(t){if(t.scheme&&!e._schemePattern.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!e._singleSlashStart.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(e._doubleSlashStart.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')},e.prototype.toString=function(t){return void 0===t&&(t=!1),t?e._asFormatted(this,!0):(this._formatted||(this._formatted=e._asFormatted(this,!1)),this._formatted)},e._asFormatted=function(t,n){var s=n?o:i,u=[],a=t.scheme,l=t.authority,c=t.path,f=t.query,h=t.fragment;if(a&&u.push(a,":"),(l||"file"===a)&&u.push("//"),l){l=l.toLowerCase();var d=l.indexOf(":");d===-1?u.push(s(l)):u.push(s(l.substr(0,d)),l.substr(d))}if(c){var p=e._upperCaseDrive.exec(c);p&&(c=p[1]?"/"+p[2].toLowerCase()+c.substr(3):p[2].toLowerCase()+c.substr(2));for(var m=0;;){var d=c.indexOf(e._slash,m);if(d===-1){u.push(s(c.substring(m)).replace(/[#?]/,r));break}u.push(s(c.substring(m,d)).replace(/[#?]/,r),e._slash),m=d+1}}return f&&u.push("?",s(f)),h&&u.push("#",s(h)),u.join(e._empty)},e.prototype.toJSON=function(){return{scheme:this.scheme,authority:this.authority,path:this.path,fsPath:this.fsPath,query:this.query,fragment:this.fragment,external:this.toString(),$mid:1}},e.revive=function(t){var n=new e;return n._scheme=t.scheme,n._authority=t.authority,n._path=t.path,n._query=t.query,n._fragment=t.fragment,n._fsPath=t.fsPath,n._formatted=t.external,e._validate(n),n},e._empty="",e._slash="/",e._regexp=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,e._driveLetterPath=/^\/[a-zA-z]:/,e._upperCaseDrive=/^(\/)?([A-Z]:)/,e._schemePattern=/^\w[\w\d+.-]*$/,e._singleSlashStart=/^\//,e._doubleSlashStart=/^\/\//,e}();Object.defineProperty(t,"__esModule",{value:!0}),t.default=s}),function(){var t={};t["WinJS/Core/_WinJS"]={};var n=function(e,n,r){var i={},o=!1,s=n.map(function(e){return"exports"===e?(o=!0,i):t[e]}),u=r.apply({},s);t[e]=o?i:u};n("WinJS/Core/_Global",[],function(){"use strict";var e="undefined"!=typeof window?window:"undefined"!=typeof self?self:"undefined"!=typeof global?global:{};return e}),n("WinJS/Core/_BaseCoreUtils",["WinJS/Core/_Global"],function(e){"use strict";function t(e){return e.supportedForProcessing=!0,e}var n=!!e.Windows;return{hasWinRT:n,markSupportedForProcessing:t,_setImmediate:e.setImmediate?e.setImmediate.bind(e):function(t){e.setTimeout(t,0)}}}),n("WinJS/Core/_WriteProfilerMark",["WinJS/Core/_Global"],function(e){"use strict";return e.msWriteProfilerMark||function(){}}),n("WinJS/Core/_Base",["WinJS/Core/_WinJS","WinJS/Core/_Global","WinJS/Core/_BaseCoreUtils","WinJS/Core/_WriteProfilerMark"],function(e,t,n,r){"use strict";function i(e,t,n){var r,i,o,s=Object.keys(t),u=Array.isArray(e);for(i=0,o=s.length;i<o;i++){var a=s[i],l=95!==a.charCodeAt(0),c=t[a];!c||"object"!=typeof c||void 0===c.value&&"function"!=typeof c.get&&"function"!=typeof c.set?l?u?e.forEach(function(e){e[a]=c}):e[a]=c:(r=r||{},r[a]={value:c,enumerable:l,configurable:!0,writable:!0}):(void 0===c.enumerable&&(c.enumerable=l),n&&c.setName&&"function"==typeof c.setName&&c.setName(n+"."+a),r=r||{},r[a]=c)}r&&(u?e.forEach(function(e){Object.defineProperties(e,r)}):Object.defineProperties(e,r))}return function(){function n(n,r){var i=n||{};if(r){var o=r.split(".");i===t&&"WinJS"===o[0]&&(i=e,o.splice(0,1));for(var s=0,u=o.length;s<u;s++){var a=o[s];i[a]||Object.defineProperty(i,a,{value:{},writable:!1,enumerable:!0,configurable:!0}),i=i[a]}}return i}function o(e,t,r){var o=n(e,t);return r&&i(o,r,t||"<ANONYMOUS>"),o}function s(e,n){return o(t,e,n)}function u(e){var t,n,i=c.uninitialized;return{setName:function(e){t=e},get:function(){switch(i){case c.initialized:return n;case c.uninitialized:i=c.working;try{r("WinJS.Namespace._lazy:"+t+",StartTM"),n=e()}finally{r("WinJS.Namespace._lazy:"+t+",StopTM"),i=c.uninitialized}return e=null,i=c.initialized,n;case c.working:throw"Illegal: reentrancy on initialization";default:throw"Illegal"}},set:function(e){switch(i){case c.working:throw"Illegal: reentrancy on initialization";default:i=c.initialized,n=e}},enumerable:!0,configurable:!0}}function a(e,r,o){var s=[e],u=null;return r&&(u=n(t,r),s.push(u)),i(s,o,r||"<ANONYMOUS>"),u}var l=e;l.Namespace||(l.Namespace=Object.create(Object.prototype));var c={uninitialized:1,working:2,initialized:3};Object.defineProperties(l.Namespace,{defineWithParent:{value:o,writable:!0,enumerable:!0,configurable:!0},define:{value:s,writable:!0,enumerable:!0,configurable:!0},_lazy:{value:u,writable:!0,enumerable:!0,configurable:!0},_moduleDefine:{value:a,writable:!0,enumerable:!0,configurable:!0}})}(),function(){function t(e,t,r){return e=e||function(){},n.markSupportedForProcessing(e),t&&i(e.prototype,t),r&&i(e,r),e}function r(e,r,o,s){if(e){r=r||function(){};var u=e.prototype;return r.prototype=Object.create(u),n.markSupportedForProcessing(r),Object.defineProperty(r.prototype,"constructor",{value:r,writable:!0,configurable:!0,enumerable:!0}),o&&i(r.prototype,o),s&&i(r,s),r}return t(r,o,s)}function o(e){e=e||function(){};var t,n;for(t=1,n=arguments.length;t<n;t++)i(e.prototype,arguments[t]);return e}e.Namespace.define("WinJS.Class",{define:t,derive:r,mix:o})}(),{Namespace:e.Namespace,Class:e.Class}}),n("WinJS/Core/_ErrorFromName",["WinJS/Core/_Base"],function(e){"use strict";var t=e.Class.derive(Error,function(e,t){this.name=e,this.message=t||e},{},{supportedForProcessing:!1});return e.Namespace.define("WinJS",{ErrorFromName:t}),t}),n("WinJS/Core/_Events",["exports","WinJS/Core/_Base"],function(e,t){"use strict";function n(e){var t="_on"+e+"state";return{get:function(){var e=this[t];return e&&e.userHandler},set:function(n){var r=this[t];n?(r||(r={wrapper:function(e){return r.userHandler(e)},userHandler:n},Object.defineProperty(this,t,{value:r,enumerable:!1,writable:!0,configurable:!0}),this.addEventListener(e,r.wrapper,!1)),r.userHandler=n):r&&(this.removeEventListener(e,r.wrapper,!1),this[t]=null)},enumerable:!0}}function r(){for(var e={},t=0,r=arguments.length;t<r;t++){var i=arguments[t];e["on"+i]=n(i)}return e}var i=t.Class.define(function(e,t,n){this.detail=t,this.target=n,this.timeStamp=Date.now(),this.type=e},{bubbles:{value:!1,writable:!1},cancelable:{value:!1,writable:!1},currentTarget:{get:function(){return this.target}},defaultPrevented:{get:function(){return this._preventDefaultCalled}},trusted:{value:!1,writable:!1},eventPhase:{value:0,writable:!1},target:null,timeStamp:null,type:null,preventDefault:function(){this._preventDefaultCalled=!0},stopImmediatePropagation:function(){this._stopImmediatePropagationCalled=!0},stopPropagation:function(){}},{supportedForProcessing:!1}),o={_listeners:null,addEventListener:function(e,t,n){n=n||!1,this._listeners=this._listeners||{};for(var r=this._listeners[e]=this._listeners[e]||[],i=0,o=r.length;i<o;i++){var s=r[i];if(s.useCapture===n&&s.listener===t)return}r.push({listener:t,useCapture:n})},dispatchEvent:function(e,t){var n=this._listeners&&this._listeners[e];if(n){var r=new i(e,t,this);n=n.slice(0,n.length);for(var o=0,s=n.length;o<s&&!r._stopImmediatePropagationCalled;o++)n[o].listener(r);return r.defaultPrevented||!1}return!1},removeEventListener:function(e,t,n){n=n||!1;var r=this._listeners&&this._listeners[e];if(r)for(var i=0,o=r.length;i<o;i++){var s=r[i];if(s.listener===t&&s.useCapture===n){r.splice(i,1),0===r.length&&delete this._listeners[e];break}}}};t.Namespace._moduleDefine(e,"WinJS.Utilities",{_createEventProperty:n,createEventProperties:r,eventMixin:o})}),n("WinJS/Core/_Trace",["WinJS/Core/_Global"],function(e){"use strict";function t(e){return e}return{_traceAsyncOperationStarting:e.Debug&&e.Debug.msTraceAsyncOperationStarting&&e.Debug.msTraceAsyncOperationStarting.bind(e.Debug)||t,_traceAsyncOperationCompleted:e.Debug&&e.Debug.msTraceAsyncOperationCompleted&&e.Debug.msTraceAsyncOperationCompleted.bind(e.Debug)||t,_traceAsyncCallbackStarting:e.Debug&&e.Debug.msTraceAsyncCallbackStarting&&e.Debug.msTraceAsyncCallbackStarting.bind(e.Debug)||t,_traceAsyncCallbackCompleted:e.Debug&&e.Debug.msTraceAsyncCallbackCompleted&&e.Debug.msTraceAsyncCallbackCompleted.bind(e.Debug)||t}}),n("WinJS/Promise/_StateMachine",["WinJS/Core/_Global","WinJS/Core/_BaseCoreUtils","WinJS/Core/_Base","WinJS/Core/_ErrorFromName","WinJS/Core/_Events","WinJS/Core/_Trace"],function(e,t,n,r,i,o){"use strict";function s(){}function u(e,t){var n;n=t&&"object"==typeof t&&"function"==typeof t.then?U:K,e._value=t,e._setState(n)}function a(e,t,n,r,i,o){return{exception:e,error:t,promise:n,handler:o,id:r,parent:i}}function l(e,t,n,r){var i=n._isException,o=n._errorId;return a(i?t:null,i?null:t,e,o,n,r)}function c(e,t,n){var r=n._isException,i=n._errorId;return b(e,i,r),a(r?t:null,r?null:t,e,i,n)}function f(e,t){var n=++Y;return b(e,n),a(null,t,e,n)}function h(e,t){var n=++Y;return b(e,n,!0),a(t,null,e,n)}function d(e,t,n,r){var i=o._traceAsyncOperationStarting("WinJS.Promise.done");y(e,{c:t,e:n,p:r,asyncOpID:i})}function p(e,t,n,r){e._value=t,g(e,t,n,r),e._setState(q)}function m(t,n){var r=t._value,i=t._listeners;if(i){t._listeners=null;var s,u;for(s=0,u=Array.isArray(i)?i.length:1;s<u;s++){var a=1===u?i:i[s],l=a.c,c=a.promise;if(o._traceAsyncOperationCompleted(a.asyncOpID,e.Debug&&e.Debug.MS_ASYNC_OP_STATUS_SUCCESS),c){o._traceAsyncCallbackStarting(a.asyncOpID);try{c._setCompleteValue(l?l(r):r)}catch(e){c._setExceptionValue(e)}finally{o._traceAsyncCallbackCompleted()}c._state!==U&&c._listeners&&n.push(c)}else J.prototype.done.call(t,l)}}}function _(t,n){var r=t._value,i=t._listeners;if(i){t._listeners=null;var s,u;for(s=0,u=Array.isArray(i)?i.length:1;s<u;s++){var a=1===u?i:i[s],c=a.e,f=a.promise,h=e.Debug&&(r&&r.name===w?e.Debug.MS_ASYNC_OP_STATUS_CANCELED:e.Debug.MS_ASYNC_OP_STATUS_ERROR);if(o._traceAsyncOperationCompleted(a.asyncOpID,h),f){var d=!1;try{c?(o._traceAsyncCallbackStarting(a.asyncOpID),d=!0,c.handlesOnError||g(f,r,l,t,c),f._setCompleteValue(c(r))):f._setChainedErrorValue(r,t)}catch(e){f._setExceptionValue(e)}finally{d&&o._traceAsyncCallbackCompleted()}f._state!==U&&f._listeners&&n.push(f)}else z.prototype.done.call(t,null,c)}}}function g(e,t,n,r,i){if(A._listeners[N]){if(t instanceof Error&&t.message===w)return;A.dispatchEvent(N,n(e,t,r,i))}}function v(e,t){var n=e._listeners;if(n){var r,i;for(r=0,i=Array.isArray(n)?n.length:1;r<i;r++){var o=1===i?n:n[r],s=o.p;if(s)try{s(t)}catch(e){}o.c||o.e||!o.promise||o.promise._progress(t)}}}function y(e,t){var n=e._listeners;n?(n=Array.isArray(n)?n:[n],n.push(t)):n=t,e._listeners=n}function b(e,t,n){e._isException=n||!1,e._errorId=t}function C(e,t,n,r){e._value=t,g(e,t,n,r),e._setState(W)}function E(e,t){var n;n=t&&"object"==typeof t&&"function"==typeof t.then?U:F,e._value=t,e._setState(n)}function S(e,t,n,r){var i=new j(e),s=o._traceAsyncOperationStarting("WinJS.Promise.then");return y(e,{promise:i,c:t,e:n,p:r,asyncOpID:s}),i}function P(n){var r;return new Q(function(i){n?r=e.setTimeout(i,n):t._setImmediate(i)},function(){r&&e.clearTimeout(r)})}function M(e,t){var n=function(){t.cancel()},r=function(){e.cancel()};return e.then(n),t.then(r,r),t}e.Debug&&(e.Debug.setNonUserCodeExceptions=!0);var L=n.Class.mix(n.Class.define(null,{},{supportedForProcessing:!1}),i.eventMixin),A=new L;A._listeners={};var N="error",w="Canceled",D=!1,k={promise:1,thenPromise:2,errorPromise:4,exceptionPromise:8,completePromise:16};k.all=k.promise|k.thenPromise|k.errorPromise|k.exceptionPromise|k.completePromise;var x,T,U,O,I,R,K,F,q,W,Y=1;x={name:"created",enter:function(e){e._setState(T)},cancel:s,done:s,then:s,_completed:s,_error:s,_notify:s,_progress:s,_setCompleteValue:s,_setErrorValue:s},T={name:"working",enter:s,cancel:function(e){e._setState(I)},done:d,then:S,_completed:u,_error:p,_notify:s,_progress:v,_setCompleteValue:E,_setErrorValue:C},U={name:"waiting",enter:function(e){var t=e._value;if(t instanceof j&&t._state!==W&&t._state!==F)y(t,{promise:e});else{var n=function(r){t._errorId?e._chainedError(r,t):(g(e,r,l,t,n),e._error(r))};n.handlesOnError=!0,t.then(e._completed.bind(e),n,e._progress.bind(e))}},cancel:function(e){e._setState(O)},done:d,then:S,_completed:u,_error:p,_notify:s,_progress:v,_setCompleteValue:E,_setErrorValue:C},O={name:"waiting_canceled",enter:function(e){e._setState(R);var t=e._value;t.cancel&&t.cancel()},cancel:s,done:d,then:S,_completed:u,_error:p,_notify:s,_progress:v,_setCompleteValue:E,_setErrorValue:C},I={name:"canceled",enter:function(e){e._setState(R),e._cancelAction()},cancel:s,done:d,then:S,_completed:u,_error:p,_notify:s,_progress:v,_setCompleteValue:E,_setErrorValue:C},R={name:"canceling",enter:function(e){var t=new Error(w);t.name=t.message,e._value=t,e._setState(q)},cancel:s,done:s,then:s,_completed:s,_error:s,_notify:s,_progress:s,_setCompleteValue:s,_setErrorValue:s},K={name:"complete_notify",enter:function(e){if(e.done=J.prototype.done,e.then=J.prototype.then,e._listeners)for(var t,n=[e];n.length;)t=n.shift(),t._state._notify(t,n);e._setState(F)},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:m,_progress:s,_setCompleteValue:s,_setErrorValue:s},F={name:"success",enter:function(e){e.done=J.prototype.done,e.then=J.prototype.then,e._cleanupAction()},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:m,_progress:s,_setCompleteValue:s,_setErrorValue:s},q={name:"error_notify",enter:function(e){if(e.done=z.prototype.done,e.then=z.prototype.then,e._listeners)for(var t,n=[e];n.length;)t=n.shift(),t._state._notify(t,n);e._setState(W)},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:_,_progress:s,_setCompleteValue:s,_setErrorValue:s},W={name:"error",enter:function(e){e.done=z.prototype.done,e.then=z.prototype.then,e._cleanupAction()},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:_,_progress:s,_setCompleteValue:s,_setErrorValue:s};var B,V=n.Class.define(null,{_listeners:null,_nextState:null,_state:null,_value:null,cancel:function(){this._state.cancel(this),this._run()},done:function(e,t,n){this._state.done(this,e,t,n)},then:function(e,t,n){return this._state.then(this,e,t,n)},_chainedError:function(e,t){var n=this._state._error(this,e,c,t);return this._run(),n},_completed:function(e){var t=this._state._completed(this,e);return this._run(),t},_error:function(e){var t=this._state._error(this,e,f);return this._run(),t},_progress:function(e){this._state._progress(this,e)},_setState:function(e){this._nextState=e},_setCompleteValue:function(e){this._state._setCompleteValue(this,e),this._run()},_setChainedErrorValue:function(e,t){var n=this._state._setErrorValue(this,e,c,t);return this._run(),n},_setExceptionValue:function(e){var t=this._state._setErrorValue(this,e,h);return this._run(),t},_run:function(){for(;this._nextState;)this._state=this._nextState,this._nextState=null,this._state.enter(this)}},{supportedForProcessing:!1}),j=n.Class.derive(V,function(e){D&&(D===!0||D&k.thenPromise)&&(this._stack=Q._getStack()),this._creator=e,this._setState(x),this._run()},{_creator:null,_cancelAction:function(){this._creator&&this._creator.cancel()},_cleanupAction:function(){this._creator=null}},{supportedForProcessing:!1}),z=n.Class.define(function(e){D&&(D===!0||D&k.errorPromise)&&(this._stack=Q._getStack()),this._value=e,g(this,e,f)},{cancel:function(){},done:function(e,t){var n=this._value;if(t)try{t.handlesOnError||g(null,n,l,this,t);var r=t(n);return void(r&&"object"==typeof r&&"function"==typeof r.done&&r.done())}catch(e){n=e}n instanceof Error&&n.message===w||Q._doneHandler(n)},then:function(e,t){if(!t)return this;var n,r=this._value;try{t.handlesOnError||g(null,r,l,this,t),n=new J(t(r))}catch(e){n=e===r?this:new H(e)}return n}},{supportedForProcessing:!1}),H=n.Class.derive(z,function(e){D&&(D===!0||D&k.exceptionPromise)&&(this._stack=Q._getStack()),this._value=e,g(this,e,h)},{},{supportedForProcessing:!1}),J=n.Class.define(function(e){if(D&&(D===!0||D&k.completePromise)&&(this._stack=Q._getStack()),e&&"object"==typeof e&&"function"==typeof e.then){var t=new j(null);return t._setCompleteValue(e),t}this._value=e},{cancel:function(){},done:function(e){if(e)try{var t=e(this._value);t&&"object"==typeof t&&"function"==typeof t.done&&t.done()}catch(e){Q._doneHandler(e)}},then:function(e){try{var t=e?e(this._value):this._value;return t===this._value?this:new J(t)}catch(e){return new H(e)}}},{supportedForProcessing:!1}),Q=n.Class.derive(V,function(e,t){D&&(D===!0||D&k.promise)&&(this._stack=Q._getStack()),this._oncancel=t,this._setState(x),this._run();try{var n=this._completed.bind(this),r=this._error.bind(this),i=this._progress.bind(this);e(n,r,i)}catch(e){this._setExceptionValue(e)}},{_oncancel:null,_cancelAction:function(){try{if(!this._oncancel)throw new Error("Promise did not implement oncancel");this._oncancel()}catch(e){e.message,e.stack;A.dispatchEvent("error",e)}},_cleanupAction:function(){this._oncancel=null}},{addEventListener:function(e,t,n){A.addEventListener(e,t,n)},any:function(e){return new Q(function(t,n){var r=Object.keys(e);0===r.length&&t();var i=0;r.forEach(function(o){Q.as(e[o]).then(function(){t({key:o,value:e[o]})},function(s){return s instanceof Error&&s.name===w?void(++i===r.length&&t(Q.cancel)):void n({key:o,value:e[o]})})})},function(){var t=Object.keys(e);t.forEach(function(t){var n=Q.as(e[t]);"function"==typeof n.cancel&&n.cancel()})})},as:function(e){return e&&"object"==typeof e&&"function"==typeof e.then?e:new J(e)},cancel:{get:function(){return B=B||new z(new r(w))}},dispatchEvent:function(e,t){return A.dispatchEvent(e,t)},is:function(e){return e&&"object"==typeof e&&"function"==typeof e.then},join:function(e){return new Q(function(t,n,r){var i=Object.keys(e),o=Array.isArray(e)?[]:{},s=Array.isArray(e)?[]:{},u=0,a=i.length,l=function(e){if(0===--a){var u=Object.keys(o).length;if(0===u)t(s);else{var l=0;i.forEach(function(e){var t=o[e];t instanceof Error&&t.name===w&&l++}),l===u?t(Q.cancel):n(o)}}else r({Key:e,Done:!0})};if(i.forEach(function(t){var n=e[t];void 0===n?u++:Q.then(n,function(e){s[t]=e,l(t)},function(e){o[t]=e,l(t)})}),a-=u,0===a)return void t(s)},function(){Object.keys(e).forEach(function(t){var n=Q.as(e[t]);"function"==typeof n.cancel&&n.cancel()})})},removeEventListener:function(e,t,n){A.removeEventListener(e,t,n)},supportedForProcessing:!1,then:function(e,t,n,r){return Q.as(e).then(t,n,r)},thenEach:function(e,t,n,r){var i=Array.isArray(e)?[]:{};return Object.keys(e).forEach(function(o){i[o]=Q.as(e[o]).then(t,n,r)}),Q.join(i)},timeout:function(e,t){var n=P(e);return t?M(n,t):n},wrap:function(e){return new J(e)},wrapError:function(e){return new z(e)},_veryExpensiveTagWithStack:{get:function(){return D},set:function(e){D=e}},_veryExpensiveTagWithStack_tag:k,_getStack:function(){if(e.Debug&&e.Debug.debuggerEnabled)try{throw new Error}catch(e){return e.stack}},_cancelBlocker:function(e,t){if(!Q.is(e))return Q.wrap(e);var n,r,i=new Q(function(e,t){n=e,r=t},function(){n=null,r=null,t&&t()});return e.then(function(e){n&&n(e)},function(e){r&&r(e)}),i}});return Object.defineProperties(Q,i.createEventProperties(N)),Q._doneHandler=function(e){t._setImmediate(function(){throw e})},{PromiseStateMachine:V,Promise:Q,state_created:x}}),n("WinJS/Promise",["WinJS/Core/_Base","WinJS/Promise/_StateMachine"],function(e,t){"use strict";return e.Namespace.define("WinJS",{Promise:t.Promise}),t.Promise});var r=t["WinJS/Core/_WinJS"];"undefined"==typeof exports&&"function"==typeof e&&e.amd?e("vs/base/common/winjs.base.raw",r):module.exports=r,"undefined"!=typeof process&&"function"==typeof process.nextTick&&(t["WinJS/Core/_BaseCoreUtils"]._setImmediate=function(e){return process.nextTick(e)})}(),e(n[2],r([30,3]),function(e,t){"use strict";function n(e){var n=e.detail,i=n.id;return n.parent?void(n.handler&&r&&delete r[i]):(r[i]=n,void(1===Object.keys(r).length&&setTimeout(function(){var e=r;r={},Object.keys(e).forEach(function(n){var r=e[n];r.exception?t.onUnexpectedError(r.exception):r.error&&t.onUnexpectedError(r.error),console.log("WARNING: Promise with no error callback:"+r.id),console.log(r),r.exception&&console.log(r.exception.stack)})},0)))}var r={};return e.Promise.addEventListener("error",n),{Promise:e.Promise,TPromise:e.Promise,PPromise:e.Promise}}),e(n[18],r([0,1,3,5,2,10,6]),function(e,t,n,r,i,s,u){"use strict";function a(e){return e&&"function"==typeof e.then}function l(e){return a(e)?e:i.TPromise.as(e)}function c(e){var t=new s.CancellationTokenSource;return new i.TPromise(function(n,r,o){var s=e(t.token);s instanceof i.TPromise?s.then(n,r,o):a(s)?s.then(n,r):n(s)},function(){t.cancel()})}function f(e,t,r){var o=e.onCancellationRequested(function(){return t.cancel()});return r&&(t=t.then(void 0,function(e){if(!n.isPromiseCanceledError(e))return i.TPromise.wrapError(e)})),h(t,function(){return o.dispose()})}function h(e,t){return new i.TPromise(function(r,i,o){e.done(function(e){try{t(e)}catch(e){n.onUnexpectedError(e)}r(e)},function(e){try{t(e)}catch(e){n.onUnexpectedError(e)}i(e)},function(e){o(e)})},function(){e.cancel()})}function d(e){function t(){return e.length?e.pop()():null}function n(e){void 0!==e&&null!==e&&r.push(e);var o=t();return o?o.then(n):i.TPromise.as(r)}var r=[];return e=e.reverse(),i.TPromise.as(null).then(n)}function p(e){var t,n=this,r=!1;return function(){return r?t:(r=!0,t=e.apply(n,arguments))}}function m(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return new i.Promise(function(n,r){return e.apply(void 0,t.concat([function(e,t){return e?r(e):n(t)}]))})}function _(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];return new i.Promise(function(r,i){return t.call.apply(t,[e].concat(n,[function(e,t){return e?i(e):r(t)}]))})}t.toThenable=l,t.asWinJsPromise=c,t.wireCancellationToken=f;var g=function(){function e(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}return e.prototype.queue=function(e){var t=this;if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){var n=function(){t.queuedPromise=null;var e=t.queue(t.queuedPromiseFactory);return t.queuedPromiseFactory=null,e};this.queuedPromise=new i.Promise(function(e,r,i){t.activePromise.then(n,n,i).done(e)},function(){t.activePromise.cancel()})}return new i.Promise(function(e,n,r){t.queuedPromise.then(e,n,r)},function(){})}return this.activePromise=e(),new i.Promise(function(e,n,r){
t.activePromise.done(function(n){t.activePromise=null,e(n)},function(e){t.activePromise=null,n(e)},r)},function(){t.activePromise.cancel()})},e}();t.Throttler=g;var v=function(){function e(){this.current=i.TPromise.as(null)}return e.prototype.queue=function(e){return this.current=this.current.then(function(){return e()})},e}();t.SimpleThrottler=v;var y=function(){function e(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.onSuccess=null,this.task=null}return e.prototype.trigger=function(e,t){var n=this;return void 0===t&&(t=this.defaultDelay),this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new i.Promise(function(e){n.onSuccess=e},function(){}).then(function(){n.completionPromise=null,n.onSuccess=null;var e=n.task;return n.task=null,e()})),this.timeout=setTimeout(function(){n.timeout=null,n.onSuccess(null)},t),this.completionPromise},e.prototype.isTriggered=function(){return null!==this.timeout},e.prototype.cancel=function(){this.cancelTimeout(),this.completionPromise&&(this.completionPromise.cancel(),this.completionPromise=null)},e.prototype.cancelTimeout=function(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)},e}();t.Delayer=y;var b=function(e){function t(t){e.call(this,t),this.throttler=new g}return o(t,e),t.prototype.trigger=function(t,n){var r=this;return e.prototype.trigger.call(this,function(){return r.throttler.queue(t)},n)},t}(y);t.ThrottledDelayer=b;var C=function(e){function t(t,n){void 0===n&&(n=0),e.call(this,t),this.minimumPeriod=n,this.periodThrottler=new g}return o(t,e),t.prototype.trigger=function(t,n){var r=this;return e.prototype.trigger.call(this,function(){return r.periodThrottler.queue(function(){return i.Promise.join([i.TPromise.timeout(r.minimumPeriod),t()]).then(function(e){return e[1]})})},n)},t}(b);t.PeriodThrottledDelayer=C;var E=function(){function e(){var e=this;this._value=new i.TPromise(function(t,n){e._completeCallback=t,e._errorCallback=n})}return Object.defineProperty(e.prototype,"value",{get:function(){return this._value},enumerable:!0,configurable:!0}),e.prototype.complete=function(e){this._completeCallback(e)},e.prototype.error=function(e){this._errorCallback(e)},e}();t.PromiseSource=E;var S=function(e){function t(t){var r,i,o;e.call(this,function(e,t,n){r=e,i=t,o=n},function(){i(n.canceled())}),t.then(r,i,o)}return o(t,e),t}(i.TPromise);t.ShallowCancelThenPromise=S,t.always=h,t.sequence=d,t.once=p;var P=function(){function e(e){this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0}return e.prototype.queue=function(e){var t=this;return new i.TPromise(function(n,r,i){t.outstandingPromises.push({factory:e,c:n,e:r,p:i}),t.consume()})},e.prototype.consume=function(){for(var e=this;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){var t=this.outstandingPromises.shift();this.runningPromises++;var n=t.factory();n.done(t.c,t.e,t.p),n.done(function(){return e.consumed()},function(){return e.consumed()})}},e.prototype.consumed=function(){this.runningPromises--,this.consume()},e}();t.Limiter=P;var M=function(e){function t(){e.call(this),this._token=-1}return o(t,e),t.prototype.dispose=function(){this.cancel(),e.prototype.dispose.call(this)},t.prototype.cancel=function(){this._token!==-1&&(r.clearTimeout(this._token),this._token=-1)},t.prototype.cancelAndSet=function(e,t){var n=this;this.cancel(),this._token=r.setTimeout(function(){n._token=-1,e()},t)},t.prototype.setIfNotSet=function(e,t){var n=this;this._token===-1&&(this._token=r.setTimeout(function(){n._token=-1,e()},t))},t}(u.Disposable);t.TimeoutTimer=M;var L=function(e){function t(){e.call(this),this._token=-1}return o(t,e),t.prototype.dispose=function(){this.cancel(),e.prototype.dispose.call(this)},t.prototype.cancel=function(){this._token!==-1&&(r.clearInterval(this._token),this._token=-1)},t.prototype.cancelAndSet=function(e,t){this.cancel(),this._token=r.setInterval(function(){e()},t)},t}(u.Disposable);t.IntervalTimer=L;var A=function(){function e(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}return e.prototype.dispose=function(){this.cancel(),this.runner=null},e.prototype.cancel=function(){this.isScheduled()&&(r.clearTimeout(this.timeoutToken),this.timeoutToken=-1)},e.prototype.setRunner=function(e){this.runner=e},e.prototype.schedule=function(e){void 0===e&&(e=this.timeout),this.cancel(),this.timeoutToken=r.setTimeout(this.timeoutHandler,e)},e.prototype.isScheduled=function(){return this.timeoutToken!==-1},e.prototype.onTimeout=function(){this.timeoutToken=-1,this.runner&&this.runner()},e}();t.RunOnceScheduler=A,t.nfcall=m,t.ninvoke=_}),e(n[29],r([0,1,3,6,2,18]),function(e,t,n,r,i,s){"use strict";function u(e){return new f(e)}var a="$initialize",l=function(){function e(e){this._workerId=-1,this._handler=e,this._lastSentReq=0,this._pendingReplies=Object.create(null)}return e.prototype.setWorkerId=function(e){this._workerId=e},e.prototype.sendMessage=function(e,t){var n=String(++this._lastSentReq),r={c:null,e:null},o=new i.TPromise(function(e,t,n){r.c=e,r.e=t},function(){});return this._pendingReplies[n]=r,this._send({vsWorker:this._workerId,req:n,method:e,args:t}),o},e.prototype.handleMessage=function(e){var t;try{t=JSON.parse(e)}catch(e){}t.vsWorker&&(this._workerId!==-1&&t.vsWorker!==this._workerId||this._handleMessage(t))},e.prototype._handleMessage=function(e){var t=this;if(e.seq){var r=e;if(!this._pendingReplies[r.seq])return void console.warn("Got reply to unknown seq");var i=this._pendingReplies[r.seq];if(delete this._pendingReplies[r.seq],r.err){var o=r.err;return r.err.$isError&&(o=new Error,o.name=r.err.name,o.message=r.err.message,o.stack=r.err.stack),void i.e(o)}return void i.c(r.res)}var s=e,u=s.req,a=this._handler.handleMessage(s.method,s.args);a.then(function(e){t._send({vsWorker:t._workerId,seq:u,res:e,err:void 0})},function(e){t._send({vsWorker:t._workerId,seq:u,res:void 0,err:n.transformErrorForSerialization(e)})})},e.prototype._send=function(e){var t=JSON.stringify(e);this._handler.sendMessage(t)},e}(),c=function(e){function t(t,n){var r=this;e.call(this),this._lastRequestTimestamp=-1;var o=null,s=null;this._worker=this._register(t.create("vs/base/common/worker/simpleWorker",function(e){r._protocol.handleMessage(e)},function(e){s(e)})),this._protocol=new l({sendMessage:function(e){r._worker.postMessage(e)},handleMessage:function(e,t){return i.TPromise.as(null)}}),this._protocol.setWorkerId(this._worker.getId());var u=null,c=window.require;"function"==typeof c.getConfig?u=c.getConfig():"undefined"!=typeof window.requirejs&&(u=window.requirejs.s.contexts._.config),this._lazyProxy=new i.TPromise(function(e,t,n){o=e,s=t},function(){}),this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),n,u]),this._onModuleLoaded.then(function(e){for(var t={},n=0;n<e.length;n++)t[e[n]]=h(e[n],f);o(t)},function(e){s(e),r._onError("Worker failed to load "+n,e)});var f=function(e,t){return r._request(e,t)},h=function(e,t){return function(){var n=Array.prototype.slice.call(arguments,0);return t(e,n)}}}return o(t,e),t.prototype.getProxyObject=function(){return new s.ShallowCancelThenPromise(this._lazyProxy)},t.prototype.getLastRequestTimestamp=function(){return this._lastRequestTimestamp},t.prototype._request=function(e,t){var n=this;return new i.TPromise(function(r,i,o){n._onModuleLoaded.then(function(){n._lastRequestTimestamp=Date.now(),n._protocol.sendMessage(e,t).then(r,i)},i)},function(){})},t.prototype._onError=function(e,t){console.error(e),console.info(t)},t}(r.Disposable);t.SimpleWorkerClient=c;var f=function(){function t(e){var t=this;this._protocol=new l({sendMessage:function(t){e(t)},handleMessage:function(e,n){return t._handleMessage(e,n)}})}return t.prototype.onmessage=function(e){this._protocol.handleMessage(e)},t.prototype._handleMessage=function(e,t){if(e===a)return this.initialize(t[0],t[1],t[2]);if(!this._requestHandler||"function"!=typeof this._requestHandler[e])return i.TPromise.wrapError(new Error("Missing requestHandler or method: "+e));try{return i.TPromise.as(this._requestHandler[e].apply(this._requestHandler,t))}catch(e){return i.TPromise.wrapError(e)}},t.prototype.initialize=function(t,n,r){var o=this;if(this._protocol.setWorkerId(t),r){"undefined"!=typeof r.baseUrl&&delete r.baseUrl,"undefined"!=typeof r.paths&&"undefined"!=typeof r.paths.vs&&delete r.paths.vs;var s=r["vs/nls"];s&&s.pseudo&&e(["vs/nls"],function(e){e.setPseudoTranslation(s.pseudo)}),r.catchError=!0,self.require.config(r)}var u,a,l=new i.TPromise(function(e,t,n){u=e,a=t});return self.require([n],function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];var n=e[0];o._requestHandler=n.create();var r=[];for(var i in o._requestHandler)"function"==typeof o._requestHandler[i]&&r.push(i);u(r)},a),l},t}();t.SimpleWorkerServer=f,t.create=u}),e(n[20],r([0,1]),function(e,t){"use strict";var n=function(){function e(t){this._defaultValue=t,this._asciiMap=e._createAsciiMap(t),this._map=[]}return e._createAsciiMap=function(e){for(var t=[],n=0;n<256;n++)t[n]=e;return t},e.prototype.set=function(e,t){e>=0&&e<256?this._asciiMap[e]=t:this._map[e]=t},e.prototype.get=function(e){return e>=0&&e<256?this._asciiMap[e]:this._map[e]||this._defaultValue},e}();t.CharacterClassifier=n}),e(n[13],r([0,1]),function(e,t){"use strict";var n=function(){function e(e,t){this.lineNumber=e,this.column=t}return e.prototype.equals=function(t){return e.equals(this,t)},e.equals=function(e,t){return!e&&!t||!!e&&!!t&&e.lineNumber===t.lineNumber&&e.column===t.column},e.prototype.isBefore=function(t){return e.isBefore(this,t)},e.isBefore=function(e,t){return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<t.column},e.prototype.isBeforeOrEqual=function(t){return e.isBeforeOrEqual(this,t)},e.isBeforeOrEqual=function(e,t){return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<=t.column},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(t){return new e(t.lineNumber,t.column)},e.isIPosition=function(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column},e}();t.Position=n}),e(n[4],r([0,1,13]),function(e,t,n){"use strict";var r=function(){function e(e,t,n,r){e>n||e===n&&t>r?(this.startLineNumber=n,this.startColumn=r,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=n,this.endColumn=r)}return e.prototype.isEmpty=function(){return e.isEmpty(this)},e.isEmpty=function(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn},e.prototype.containsPosition=function(t){return e.containsPosition(this,t)},e.containsPosition=function(e,t){return!(t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber)&&(!(t.lineNumber===e.startLineNumber&&t.column<e.startColumn)&&!(t.lineNumber===e.endLineNumber&&t.column>e.endColumn))},e.prototype.containsRange=function(t){return e.containsRange(this,t)},e.containsRange=function(e,t){return!(t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber)&&(!(t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber)&&(!(t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn)&&!(t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn)))},e.prototype.plusRange=function(t){return e.plusRange(this,t)},e.plusRange=function(t,n){var r,i,o,s;return n.startLineNumber<t.startLineNumber?(r=n.startLineNumber,i=n.startColumn):n.startLineNumber===t.startLineNumber?(r=n.startLineNumber,i=Math.min(n.startColumn,t.startColumn)):(r=t.startLineNumber,i=t.startColumn),n.endLineNumber>t.endLineNumber?(o=n.endLineNumber,s=n.endColumn):n.endLineNumber===t.endLineNumber?(o=n.endLineNumber,s=Math.max(n.endColumn,t.endColumn)):(o=t.endLineNumber,s=t.endColumn),new e(r,i,o,s)},e.prototype.intersectRanges=function(t){return e.intersectRanges(this,t)},e.intersectRanges=function(t,n){var r=t.startLineNumber,i=t.startColumn,o=t.endLineNumber,s=t.endColumn,u=n.startLineNumber,a=n.startColumn,l=n.endLineNumber,c=n.endColumn;return r<u?(r=u,i=a):r===u&&(i=Math.max(i,a)),o>l?(o=l,s=c):o===l&&(s=Math.min(s,c)),r>o?null:r===o&&i>s?null:new e(r,i,o,s)},e.prototype.equalsRange=function(t){return e.equalsRange(this,t)},e.equalsRange=function(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn},e.prototype.getEndPosition=function(){return new n.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new n.Position(this.startLineNumber,this.startColumn)},e.prototype.cloneRange=function(){return new e(this.startLineNumber,this.startColumn,this.endLineNumber,this.endColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(t,n){return new e(this.startLineNumber,this.startColumn,t,n)},e.prototype.setStartPosition=function(t,n){return new e(t,n,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return e.collapseToStart(this)},e.collapseToStart=function(t){return new e(t.startLineNumber,t.startColumn,t.startLineNumber,t.startColumn)},e.lift=function(t){return t?new e(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn):null},e.isIRange=function(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn},e.areIntersectingOrTouching=function(e,t){return!(e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn)&&!(t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn)},e.compareRangesUsingStarts=function(e,t){var n=0|e.startLineNumber,r=0|t.startLineNumber,i=0|e.startColumn,o=0|t.startColumn,s=0|e.endLineNumber,u=0|t.endLineNumber,a=0|e.endColumn,l=0|t.endColumn;return n===r?i===o?s===u?a-l:s-u:i-o:n-r},e.compareRangesUsingEnds=function(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber},e.spansMultipleLines=function(e){return e.endLineNumber>e.startLineNumber},e}();t.Range=r}),e(n[23],r([0,1,4]),function(e,t,n){"use strict";!function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"}(t.SelectionDirection||(t.SelectionDirection={}));var r=t.SelectionDirection,i=function(e){function t(t,n,r,i){e.call(this,t,n,r,i),this.selectionStartLineNumber=t,this.selectionStartColumn=n,this.positionLineNumber=r,this.positionColumn=i}return o(t,e),t.prototype.clone=function(){return new t(this.selectionStartLineNumber,this.selectionStartColumn,this.positionLineNumber,this.positionColumn)},t.prototype.toString=function(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"},t.prototype.equalsSelection=function(e){return t.selectionsEqual(this,e)},t.selectionsEqual=function(e,t){return e.selectionStartLineNumber===t.selectionStartLineNumber&&e.selectionStartColumn===t.selectionStartColumn&&e.positionLineNumber===t.positionLineNumber&&e.positionColumn===t.positionColumn},t.prototype.getDirection=function(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?r.LTR:r.RTL},t.prototype.setEndPosition=function(e,n){return this.getDirection()===r.LTR?new t(this.startLineNumber,this.startColumn,e,n):new t(e,n,this.startLineNumber,this.startColumn)},t.prototype.setStartPosition=function(e,n){return this.getDirection()===r.LTR?new t(e,n,this.endLineNumber,this.endColumn):new t(this.endLineNumber,this.endColumn,e,n)},t.liftSelection=function(e){return new t(e.selectionStartLineNumber,e.selectionStartColumn,e.positionLineNumber,e.positionColumn)},t.selectionsArrEqual=function(e,t){if(e&&!t||!e&&t)return!1;if(!e&&!t)return!0;if(e.length!==t.length)return!1;for(var n=0,r=e.length;n<r;n++)if(!this.selectionsEqual(e[n],t[n]))return!1;return!0},t.isISelection=function(e){return e&&"number"==typeof e.selectionStartLineNumber&&"number"==typeof e.selectionStartColumn&&"number"==typeof e.positionLineNumber&&"number"==typeof e.positionColumn},t.createWithDirection=function(e,n,i,o,s){return s===r.LTR?new t(e,n,i,o):new t(i,o,e,n)},t}(n.Range);t.Selection=i}),e(n[24],r([0,1,15,8]),function(e,t,n,r){"use strict";function i(e,t,r){var i=new n.LcsDiff(e,t,r);return i.ComputeDiff()}function s(e){if(e.length<=1)return e;var t,n,r,i,o,s,u=[e[0]],l=u[0];for(t=1,n=e.length;t<n;t++)s=e[t],r=s.originalStart-(l.originalStart+l.originalLength),i=s.modifiedStart-(l.modifiedStart+l.modifiedLength),o=Math.min(r,i),o<a?(l.originalLength=s.originalStart+s.originalLength-l.originalStart,l.modifiedLength=s.modifiedStart+s.modifiedLength-l.modifiedStart):(u.push(s),l=s);return u}var u=5e3,a=3,l=function(){function e(e,t,n){this.buffer=e,this.startMarkers=t,this.endMarkers=n}return e.prototype.equals=function(t){if(!(t instanceof e))return!1;var n=t;if(this.getLength()!==n.getLength())return!1;for(var r=0,i=this.getLength();r<i;r++){var o=this.getElementHash(r),s=n.getElementHash(r);if(o!==s)return!1}return!0},e.prototype.getLength=function(){return this.startMarkers.length},e.prototype.getElementHash=function(e){return this.buffer.substring(this.startMarkers[e].offset,this.endMarkers[e].offset)},e.prototype.getStartLineNumber=function(e){return e===this.startMarkers.length?this.startMarkers[e-1].lineNumber+1:this.startMarkers[e].lineNumber},e.prototype.getStartColumn=function(e){return this.startMarkers[e].column},e.prototype.getEndLineNumber=function(e){return this.endMarkers[e].lineNumber},e.prototype.getEndColumn=function(e){return this.endMarkers[e].column},e}(),c=function(e){function t(n,r){var i,o,s,u,a,l="",c=[],f=[];for(s=0,i=0,o=n.length;i<o;i++)l+=n[i],u=1,a=n[i].length+1,r&&(u=t._getFirstNonBlankColumn(n[i],1),a=t._getLastNonBlankColumn(n[i],1)),c.push({offset:s+u-1,lineNumber:i+1,column:u}),f.push({offset:s+a-1,lineNumber:i+1,column:a}),s+=n[i].length;e.call(this,l,c,f)}return o(t,e),t._getFirstNonBlankColumn=function(e,t){var n=r.firstNonWhitespaceIndex(e);return n===-1?t:n+1},t._getLastNonBlankColumn=function(e,t){var n=r.lastNonWhitespaceIndex(e);return n===-1?t:n+2},t.prototype.getCharSequence=function(e,t){var n,r,i,o,s=[],u=[];for(n=e;n<=t;n++)for(i=this.startMarkers[n],o=this.endMarkers[n],r=i.offset;r<o.offset;r++)s.push({offset:r,lineNumber:i.lineNumber,column:i.column+(r-i.offset)}),u.push({offset:r+1,lineNumber:i.lineNumber,column:i.column+(r-i.offset)+1});return new l(this.buffer,s,u)},t}(l),f=function(){function e(e,t,n){0===e.originalLength?(this.originalStartLineNumber=0,this.originalStartColumn=0,this.originalEndLineNumber=0,this.originalEndColumn=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalStartColumn=t.getStartColumn(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1),this.originalEndColumn=t.getEndColumn(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=0,this.modifiedStartColumn=0,this.modifiedEndLineNumber=0,this.modifiedEndColumn=0):(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart),this.modifiedStartColumn=n.getStartColumn(e.modifiedStart),this.modifiedEndLineNumber=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1),this.modifiedEndColumn=n.getEndColumn(e.modifiedStart+e.modifiedLength-1))}return e}(),h=function(){function e(e,t,n,r,o){if(0===e.originalLength?(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart)-1,this.originalEndLineNumber=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart)-1,this.modifiedEndLineNumber=0):(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart),this.modifiedEndLineNumber=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1)),0!==e.originalLength&&0!==e.modifiedLength&&r()){var u=t.getCharSequence(e.originalStart,e.originalStart+e.originalLength-1),a=n.getCharSequence(e.modifiedStart,e.modifiedStart+e.modifiedLength-1),l=i(u,a,r);o&&(l=s(l)),this.charChanges=[];for(var c=0,h=l.length;c<h;c++)this.charChanges.push(new f(l[c],u,a))}}return e}(),d=function(){function e(e,t,n){this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.maximumRunTimeMs=u,this.original=new c(e,this.shouldIgnoreTrimWhitespace),this.modified=new c(t,this.shouldIgnoreTrimWhitespace),n.shouldConsiderTrimWhitespaceInEmptyCase&&this.shouldIgnoreTrimWhitespace&&this.original.equals(this.modified)&&(this.shouldIgnoreTrimWhitespace=!1,this.original=new c(e,this.shouldIgnoreTrimWhitespace),this.modified=new c(t,this.shouldIgnoreTrimWhitespace))}return e.prototype.computeDiff=function(){this.computationStartTime=(new Date).getTime();for(var e=i(this.original,this.modified,this._continueProcessingPredicate.bind(this)),t=[],n=0,r=e.length;n<r;n++)t.push(new h(e[n],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldPostProcessCharChanges));return t},e.prototype._continueProcessingPredicate=function(){if(0===this.maximumRunTimeMs)return!0;var e=(new Date).getTime();return e-this.computationStartTime<this.maximumRunTimeMs},e}();t.DiffComputer=d}),e(n[25],r([0,1]),function(e,t){"use strict";function n(e){void 0===e&&(e="");for(var n=t.USUAL_WORD_SEPARATORS,r="(-?\\d*\\.\\d\\w*)|([^",i=0;i<n.length;i++)e.indexOf(n[i])>=0||(r+="\\"+n[i]);return r+="\\s]+)",new RegExp(r,"g")}function r(e){var n=t.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)n=e;else{var r="g";e.ignoreCase&&(r+="i"),e.multiline&&(r+="m"),n=new RegExp(e.source,r)}return n.lastIndex=0,n}function i(e,t,n,r){var i,o,s,u,a,l,c=n.match(t);if(c)for(i=0;i<c.length;i++)if(l=c[i].trim(),l.length>0&&(o=n.indexOf(l,s),s=o+l.length,u=r+o+1,a=r+s+1,u<=e&&e<=a))return{word:l,startColumn:u,endColumn:a};return null}t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",t.createWordRegExp=n,t.DEFAULT_WORD_REGEXP=n(),t.ensureValidWordDefinition=r,t.getWordAtText=i}),e(n[26],r([0,1,20]),function(e,t,n){"use strict";function r(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?l.computeLinks(e):[]}var i;!function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept"}(i||(i={}));var o,s=function(){function e(e){for(var t=0,n=0,r=0,i=e.length;r<i;r++){var o=e[r],s=o[0],u=o[1],a=o[2];u>t&&(t=u),s>n&&(n=s),a>n&&(n=a)}for(var l=[],r=0;r<=n;r++){for(var c=[],f=0;f<=t;f++)c[f]=0;l[r]=c}for(var r=0,i=e.length;r<i;r++){var h=e[r],s=h[0],u=h[1],a=h[2];l[s][u]=a}this._states=l,this._maxCharCode=t}return e.prototype.nextState=function(e,t){return t<0||t>this._maxCharCode?0:this._states[e][t]},e}(),u=new s([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]]);!function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"}(o||(o={}));var a=function(){for(var e=new n.CharacterClassifier(0),t=" \t<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…",r=0;r<t.length;r++)e.set(t.charCodeAt(r),1);for(var i=".,;",r=0;r<i.length;r++)e.set(i.charCodeAt(r),2);return e}(),l=function(){function e(){}return e._createLink=function(e,t,n,r){var i=r-1;do{var o=e.charCodeAt(i),s=a.get(o);if(2!==s)break;i--}while(i>n);return{range:{startLineNumber:t,startColumn:n+1,endLineNumber:t,endColumn:i+2},url:e.substring(n,i+1)}},e.computeLinks=function(t){for(var n=[],r=1,i=t.getLineCount();r<=i;r++){for(var o=t.getLineContent(r),s=o.length,l=0,c=0,f=1,h=!1,d=!1,p=!1;l<s;){var m=!1,_=o.charCodeAt(l);if(13===f){var g=void 0;switch(_){case 40:h=!0,g=0;break;case 41:g=h?0:1;break;case 91:d=!0,g=0;break;case 93:g=d?0:1;break;case 123:p=!0,g=0;break;case 125:g=p?0:1;break;default:g=a.get(_)}1===g&&(n.push(e._createLink(o,r,c,l)),m=!0)}else if(12===f){var g=a.get(_);1===g?m=!0:f=13}else f=u.nextState(f,_),0===f&&(m=!0);m&&(f=1,h=!1,d=!1,p=!1,c=l+1),l++}13===f&&n.push(e._createLink(o,r,c,s))}return n},e}();t.computeLinks=r}),e(n[27],r([0,1]),function(e,t){"use strict";var n=function(){function e(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return e.prototype.navigateValueSet=function(e,t,n,r,i){if(e&&t){var o=this.doNavigateValueSet(t,i);if(o)return{range:e,value:o}}if(n&&r){var o=this.doNavigateValueSet(r,i);if(o)return{range:n,value:o}}return null},e.prototype.doNavigateValueSet=function(e,t){var n=this.numberReplace(e,t);return null!==n?n:this.textReplace(e,t)},e.prototype.numberReplace=function(e,t){var n=Math.pow(10,e.length-(e.lastIndexOf(".")+1)),r=Number(e),i=parseFloat(e);return isNaN(r)||isNaN(i)||r!==i?null:0!==r||t?(r=Math.floor(r*n),r+=t?n:-n,String(r/n)):null},e.prototype.textReplace=function(e,t){return this.valueSetsReplace(this._defaultValueSet,e,t)},e.prototype.valueSetsReplace=function(e,t,n){for(var r=null,i=0,o=e.length;null===r&&i<o;i++)r=this.valueSetReplace(e[i],t,n);return r},e.prototype.valueSetReplace=function(e,t,n){var r=e.indexOf(t);return r>=0?(r+=n?1:-1,r<0?r=e.length-1:r%=e.length,e[r]):null},e.INSTANCE=new e,e}();t.BasicInplaceReplace=n}),e(n[28],r([0,1,9,21,13,4,23,2,10,11]),function(e,t,n,r,i,o,s,u,a,l){"use strict";function c(){return{editor:void 0,languages:void 0,CancellationTokenSource:a.CancellationTokenSource,Emitter:n.Emitter,KeyCode:d,KeyMod:h,Position:i.Position,Range:o.Range,Selection:s.Selection,SelectionDirection:s.SelectionDirection,Severity:f,Promise:u.TPromise,Uri:l.default}}!function(e){e[e.Ignore=0]="Ignore",e[e.Info=1]="Info",e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(t.Severity||(t.Severity={}));var f=t.Severity,h=function(){function e(){}return e.chord=function(e,t){return r.KeyChord(e,t)},e.CtrlCmd=32768,e.Shift=16384,e.Alt=8192,e.WinCtrl=4096,e}();t.KeyMod=h,function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.MAX_VALUE=109]="MAX_VALUE"}(t.KeyCode||(t.KeyCode={}));var d=t.KeyCode;t.createMonacoBaseAPI=c}),e(n[19],r([0,1]),function(e,t){"use strict";var n=function(){function e(e,t){this.index=e,this.remainder=t}return e}();t.PrefixSumIndexOfResult=n;var r=function(){function e(e){this.values=e,this.prefixSum=[];for(var t=0,n=this.values.length;t<n;t++)this.prefixSum[t]=0;this.prefixSumValidIndex=-1}return e.prototype.getCount=function(){return this.values.length},e.prototype.insertValue=function(e,t){e=Math.floor(e),t=Math.floor(t),this.values.splice(e,0,t),this.prefixSum.splice(e,0,0),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.insertValues=function(t,n){t=Math.floor(t),0!==n.length&&(this.values=this.values.slice(0,t).concat(n).concat(this.values.slice(t)),this.prefixSum=this.prefixSum.slice(0,t).concat(e._zeroArray(n.length)).concat(this.prefixSum.slice(t)),t-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=t-1))},e._zeroArray=function(e){e=Math.floor(e);for(var t=[],n=0;n<e;n++)t[n]=0;return t},e.prototype.changeValue=function(e,t){e=Math.floor(e),t=Math.floor(t),this.values[e]!==t&&(this.values[e]=t,e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1))},e.prototype.removeValues=function(e,t){e=Math.floor(e),t=Math.floor(t),this.values.splice(e,t),this.prefixSum.splice(e,t),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.getTotalValue=function(){return 0===this.values.length?0:this.getAccumulatedValue(this.values.length-1)},e.prototype.getAccumulatedValue=function(e){if(e=Math.floor(e),e<0)return 0;if(e<=this.prefixSumValidIndex)return this.prefixSum[e];var t=this.prefixSumValidIndex+1;0===t&&(this.prefixSum[0]=this.values[0],t++),e>=this.values.length&&(e=this.values.length-1);for(var n=t;n<=e;n++)this.prefixSum[n]=this.prefixSum[n-1]+this.values[n];return this.prefixSumValidIndex=Math.max(this.prefixSumValidIndex,e),this.prefixSum[e]},e.prototype.getIndexOf=function(e){e=Math.floor(e);for(var t,r,i,o=0,s=this.values.length-1;o<=s;)if(t=o+(s-o)/2|0,r=this.getAccumulatedValue(t),i=r-this.values[t],e<i)s=t-1;else{if(!(e>=r))break;o=t+1}return new n(t,e-i)},e}();t.PrefixSumComputer=r}),e(n[17],r([0,1,19]),function(e,t,n){"use strict";var r=function(){function e(e,t,n,r){this._uri=e,this._lines=t,this._eol=n,this._versionId=r}return e.prototype.dispose=function(){this._lines.length=0},Object.defineProperty(e.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),e.prototype.getText=function(){return this._lines.join(this._eol)},e.prototype.onEvents=function(e){
for(var t=null,n=0,r=e.length;n<r;n++){var i=e[n];i.eol&&(t=i.eol)}t&&t!==this._eol&&(this._eol=t,this._lineStarts=null);for(var o=-1,n=0,r=e.length;n<r;n++){var i=e[n];this._acceptDeleteRange(i.range),this._acceptInsertText({lineNumber:i.range.startLineNumber,column:i.range.startColumn},i.text),o=Math.max(o,i.versionId)}o!==-1&&(this._versionId=o)},e.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var e=[],t=this._eol.length,r=0,i=this._lines.length;r<i;r++)e.push(this._lines[r].length+t);this._lineStarts=new n.PrefixSumComputer(e)}},e.prototype._setLineText=function(e,t){this._lines[e]=t,this._lineStarts&&this._lineStarts.changeValue(e,this._lines[e].length+this._eol.length)},e.prototype._acceptDeleteRange=function(e){if(e.startLineNumber===e.endLineNumber){if(e.startColumn===e.endColumn)return;return void this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.startLineNumber-1].substring(e.endColumn-1))}this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.endLineNumber-1].substring(e.endColumn-1)),this._lines.splice(e.startLineNumber,e.endLineNumber-e.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(e.startLineNumber,e.endLineNumber-e.startLineNumber)},e.prototype._acceptInsertText=function(e,t){if(0!==t.length){var n=t.split(/\r\n|\r|\n/);if(1===n.length)return void this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]+this._lines[e.lineNumber-1].substring(e.column-1));n[n.length-1]+=this._lines[e.lineNumber-1].substring(e.column-1),this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]);for(var r=new Array(n.length-1),i=1;i<n.length;i++)this._lines.splice(e.lineNumber+i-1,0,n[i]),r[i-1]=n[i].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(e.lineNumber,r)}},e}();t.MirrorModel2=r}),e(n[31],r([0,1,11,2,4,22,24,17,26,27,25,28]),function(e,t,n,r,i,s,u,a,l,c,f,h){"use strict";function d(){return new _}var p=function(e){function t(){e.apply(this,arguments)}return o(t,e),Object.defineProperty(t.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),t.prototype.getValue=function(){return this.getText()},t.prototype.getLinesContent=function(){return this._lines.slice(0)},t.prototype.getLineCount=function(){return this._lines.length},t.prototype.getLineContent=function(e){return this._lines[e-1]},t.prototype.getWordAtPosition=function(e,t){var n=f.getWordAtText(e.column,f.ensureValidWordDefinition(t),this._lines[e.lineNumber-1],0);return n?new i.Range(e.lineNumber,n.startColumn,e.lineNumber,n.endColumn):null},t.prototype.getWordUntilPosition=function(e,t){var n=this.getWordAtPosition(e,t);return n?{word:this._lines[e.lineNumber-1].substring(n.startColumn-1,e.column-1),startColumn:n.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},t.prototype._getAllWords=function(e){var t=this,n=[];return this._lines.forEach(function(r){t._wordenize(r,e).forEach(function(e){n.push(r.substring(e.start,e.end))})}),n},t.prototype.getAllUniqueWords=function(e,t){var n=!1,r={};return this._getAllWords(e).filter(function(e){return t&&!n&&t===e?(n=!0,!1):!r[e]&&(r[e]=!0,!0)})},t.prototype._wordenize=function(e,t){for(var n,r=[];(n=t.exec(e))&&0!==n[0].length;)r.push({start:n.index,end:n.index+n[0].length});return r},t.prototype.getValueInRange=function(e){if(e.startLineNumber===e.endLineNumber)return this._lines[e.startLineNumber-1].substring(e.startColumn-1,e.endColumn-1);var t=this._eol,n=e.startLineNumber-1,r=e.endLineNumber-1,i=[];i.push(this._lines[n].substring(e.startColumn-1));for(var o=n+1;o<r;o++)i.push(this._lines[o]);return i.push(this._lines[r].substring(0,e.endColumn-1)),i.join(t)},t}(a.MirrorModel2);t.MirrorModel=p;var m=function(){function e(){this._foreignModule=null}return e.prototype.computeDiff=function(e,t,n){var i=this._getModel(e),o=this._getModel(t);if(!i||!o)return null;var s=i.getLinesContent(),a=o.getLinesContent(),l=new u.DiffComputer(s,a,{shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:n,shouldConsiderTrimWhitespaceInEmptyCase:!0});return r.TPromise.as(l.computeDiff())},e.prototype.computeDirtyDiff=function(e,t,n){var i=this._getModel(e),o=this._getModel(t);if(!i||!o)return null;var s=i.getLinesContent(),a=o.getLinesContent(),l=new u.DiffComputer(s,a,{shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:n,shouldConsiderTrimWhitespaceInEmptyCase:!1});return r.TPromise.as(l.computeDiff())},e.prototype.computeLinks=function(e){var t=this._getModel(e);return t?r.TPromise.as(l.computeLinks(t)):null},e.prototype.textualSuggest=function(e,t,n,i){var o=this._getModel(e);return o?r.TPromise.as(this._suggestFiltered(o,t,new RegExp(n,i))):null},e.prototype._suggestFiltered=function(e,t,n){var r=this._suggestUnfiltered(e,t,n);return{currentWord:r.currentWord,suggestions:r.suggestions.filter(function(e){return!!s.fuzzyContiguousFilter(r.currentWord,e.label)}),incomplete:r.incomplete}},e.prototype._suggestUnfiltered=function(e,t,n){var r=e.getWordUntilPosition(t,n).word,i=e.getAllUniqueWords(n,r),o=i.filter(function(e){return!/^-?\d*\.?\d/.test(e)}).map(function(e){return{type:"text",label:e,insertText:e,noAutoAccept:!0}});return{currentWord:r,suggestions:o}},e.prototype.navigateValueSet=function(e,t,n,i,o){var s=this._getModel(e);if(!s)return null;var u=new RegExp(i,o);t.startColumn===t.endColumn&&(t.endColumn+=1);var a=s.getValueInRange(t),l=s.getWordAtPosition({lineNumber:t.startLineNumber,column:t.startColumn},u),f=null;null!==l&&(f=s.getValueInRange(l));var h=c.BasicInplaceReplace.INSTANCE.navigateValueSet(t,a,l,f,n);return r.TPromise.as(h)},e.prototype.loadForeignModule=function(e,t){var n=this;return new r.TPromise(function(r,i){self.require([e],function(e){var i={getMirrorModels:function(){return n._getModels()}};n._foreignModule=e.create(i,t);var o=[];for(var s in n._foreignModule)"function"==typeof n._foreignModule[s]&&o.push(s);r(o)},i)})},e.prototype.fmr=function(e,t){if(!this._foreignModule||"function"!=typeof this._foreignModule[e])return r.TPromise.wrapError(new Error("Missing requestHandler or method: "+e));try{return r.TPromise.as(this._foreignModule[e].apply(this._foreignModule,t))}catch(e){return r.TPromise.wrapError(e)}},e}();t.BaseEditorSimpleWorker=m;var _=function(e){function t(){e.call(this),this._models=Object.create(null)}return o(t,e),t.prototype.dispose=function(){this._models=Object.create(null)},t.prototype._getModel=function(e){return this._models[e]},t.prototype._getModels=function(){var e=this,t=[];return Object.keys(this._models).forEach(function(n){return t.push(e._models[n])}),t},t.prototype.acceptNewModel=function(e){this._models[e.url]=new p(n.default.parse(e.url),e.value.lines,e.value.EOL,e.versionId)},t.prototype.acceptModelChanged=function(e,t){if(this._models[e]){var n=this._models[e];n.onEvents(t)}},t.prototype.acceptRemovedModel=function(e){this._models[e]&&delete this._models[e]},t}(m);t.EditorSimpleWorkerImpl=_,t.create=d;var g=self,v="function"==typeof g.importScripts;v&&(g.monaco=h.createMonacoBaseAPI())}),function(){"use strict";var e=self.MonacoEnvironment,t=e&&e.baseUrl?e.baseUrl:"../../../";"function"==typeof self.define&&self.define.amd||importScripts(t+"vs/loader.js"),require.config({baseUrl:t,catchError:!0});var n=function(e){require([e],function(e){setTimeout(function(){var t=e.create(function(e){self.postMessage(e)},null);for(self.onmessage=function(e){return t.onmessage(e.data)};i.length>0;)self.onmessage(i.shift())},0)})},r=!0,i=[];self.onmessage=function(e){return r?(r=!1,void n(e.data)):void i.push(e)}}()}).call(this);
//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map